VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsToolBar2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'################################################################################
' Modul        : clsToolBar
' Beschreibung : ComClt32.ocx Replacement
'                fr die ToolBar (lsst sich auch auf VB-Controls verwenden)
'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Sonntag, 16. September 2002
'
' Copyright (C) 2002 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Christoph@ActiveVB.de

Implements iSubClass

Private Const CCM_FIRST As Long = &H2000
Private Const CCM_SETUNICODEFORMAT As Long = (CCM_FIRST + 5)

Private Const CCS_NOPARENTALIGN = &H8&
Private Const CCS_NORESIZE = &H4&
Private Const CCS_NODIVIDER = &H40&

Private Const WS_CHILD = &H40000000
Private Const WS_CLIPCHILDREN = &H2000000
Private Const WS_VISIBLE = &H10000000

Private Const WM_USER = &H400
Private Const WM_COMMAND = &H111
Private Const WM_ERASEBKGND = 20

Private Const TB_BUTTONSTRUCTSIZE = (WM_USER + 30)
Private Const TB_SETBITMAPSIZE = (WM_USER + 32)
Private Const TB_ADDBUTTONS = (WM_USER + 20)
Private Const TB_SETIMAGELIST = (WM_USER + 48)
Private Const TB_BUTTONCOUNT = (WM_USER + 24)
Private Const TB_GETITEMRECT = (WM_USER + 29)
Private Const TB_COMMANDTOINDEX = (WM_USER + 25)
Private Const TB_SETSTATE = (WM_USER + 17)
Private Const TB_GETSTATE = (WM_USER + 18)
Private Const TB_GETBUTTON = (WM_USER + 23)
Private Const TB_GETRECT = (WM_USER + 51)
Private Const TB_SETDISABLEDIMAGELIST As Long = (WM_USER + 54)

Private Const WM_NOTIFY = &H4E
Private Const TTN_FIRST = (-520)
Private Const TTN_GETDISPINFOA = (TTN_FIRST - 0)
Private Const TTN_NEEDTEXTA = TTN_GETDISPINFOA
Private Const TTN_NEEDTEXTW = (TTN_FIRST - 10)

Private Const TBSTATE_ENABLED = &H4

Private Const TBSTYLE_TOOLTIPS = &H100
Private Const TBSTYLE_FLAT = &H800

Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOMOVE = &H2

Private Type TBBUTTON
   iBitmap As Long
   idCommand As Long
   fsState As Byte
   fsStyle As Byte
   bReserved1 As Byte
   bReserved2 As Byte
   dwData As Long
   iString As Long
End Type

Private Type ToolTipText
   hdr As NMHDR
   lpszText As Long
   szText As String * 80
   hinst As Long
   uFlags As Long
End Type

Private Type InitCommonControlsEx
    dwSize As Long
    dwICC As Long
End Type

Private Type ButtonInfoStore
    wID As Integer
    sTipText As String
End Type

Private m_tBInfo() As ButtonInfoStore

'USER32
Private Declare Function CreateWindowExW Lib "user32.dll" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function InitCommonControlsEx Lib "comctl32.dll" (ByRef TLPINITCOMMONCONTROLSEX As InitCommonControlsEx) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetBkColor Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function GetThemeSysColorBrush Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal iColorId As Long) As Long

Public hWnd As Long
Private m_iID As Long
Private sToolTipBuffer As String

Private cSubClassing As New cSubclass
Public Event ButtonClick(ByVal mIndex As Long)

Private Sub Class_Initialize()
    Dim InitCC As InitCommonControlsEx
    InitCC.dwICC = &H400
    InitCC.dwSize = Len(InitCC)
    InitCommonControlsEx InitCC
End Sub

Public Sub Create(mParent As Long, X As Long, Y As Long, Width As Long, Height As Long)
    Dim dwStyle As Long
    Dim lR As Long
    Dim Button As TBBUTTON
    
    ReDim m_tBInfo(0)

    dwStyle = WS_CHILD Or WS_VISIBLE Or WS_CLIPCHILDREN
    dwStyle = dwStyle Or CCS_NOPARENTALIGN Or CCS_NORESIZE Or CCS_NODIVIDER
    dwStyle = dwStyle Or TBSTYLE_TOOLTIPS Or TBSTYLE_FLAT
      
    If UNICODE Then
        'UNICODE
        hWnd = CreateWindowExW(0, StrConv("ToolbarWindow32", vbUnicode), StrConv("", vbUnicode), dwStyle, X, Y, Width, Height, mParent, 0&, App.hInstance, 0&)
        SendMessageByLongW hWnd, CCM_SETUNICODEFORMAT, 1, 0
        lR = SendMessageByLong(hWnd, TB_BUTTONSTRUCTSIZE, LenB(Button), 0)
        lR = SendMessageByLongW(hWnd, TB_SETBITMAPSIZE, 0, 16 + (16 * &H10000))
     Else
        'ANSI
        hWnd = CreateWindowEx(0, "ToolbarWindow32", "", dwStyle, X, Y, Width, Height, mParent, 0&, App.hInstance, 0&)
        SendMessageByLong hWnd, CCM_SETUNICODEFORMAT, 0, 0
        lR = SendMessageByLong(hWnd, TB_BUTTONSTRUCTSIZE, LenB(Button), 0)
        lR = SendMessageByLong(hWnd, TB_SETBITMAPSIZE, 0, 16 + (16 * &H10000))
    End If
        
    cSubClassing.AddMsg WM_COMMAND, MSG_BEFORE
    cSubClassing.AddMsg WM_NOTIFY, MSG_BEFORE
    cSubClassing.AddMsg WM_ERASEBKGND, MSG_AFTER
    cSubClassing.Subclass mParent, Me

End Sub

Public Property Get Width() As Long
    Width = ToolbarWidth * mTwipsPerPixelX
End Property

Public Sub AddButton(Optional mImage As Long = -1, Optional mStyle As TBStyles, Optional ToolTipText As String = "")
    Dim tB As TBBUTTON
    Dim lR As Long
    With tB
       .iBitmap = mImage
       .idCommand = NewButtonID
       .fsState = TBSTATE_ENABLED
       .fsStyle = mStyle
       .dwData = 0
       .iString = 0
    End With
    lR = SendMessage(hWnd, TB_ADDBUTTONS, 1, tB)
    ReDim Preserve m_tBInfo(UBound(m_tBInfo) + 1)
    m_tBInfo(UBound(m_tBInfo)).sTipText = ToolTipText
    m_tBInfo(UBound(m_tBInfo)).wID = tB.idCommand
    ResizeToolbar
End Sub

Public Property Let ButtonEnabled(mID As Long, bState As Boolean)
    Dim fState As Long
    fState = SendMessageLong(hWnd, TB_GETSTATE, mID, 0)
    If (bState) Then
        fState = fState Or TBSTATE_ENABLED
    Else
        fState = fState And Not TBSTATE_ENABLED
    End If
    SendMessageLong hWnd, TB_SETSTATE, mID, fState
End Property

Public Property Let ButtonTipText(mID As Long, sText As String)
    m_tBInfo(mID).sTipText = sText
End Property

Public Property Let ImageList(hImageList As Long)
    SendMessageLong hWnd, TB_SETIMAGELIST, 0, hImageList
End Property

Private Sub Class_Terminate()
    DestroyWindow hWnd
    cSubClassing.UnSubclass
    Set cSubClassing = Nothing
End Sub

Public Sub ResizeToolbar()
    Dim tR As RECT, tPR As RECT, tCR As RECT
    Dim tP As POINTAPI
    Dim lCount As Long
    Dim lW As Long, lH As Long
    lCount = SendMessageLong(hWnd, TB_BUTTONCOUNT, 0, 0)
    If (lCount > 0) Then
        lW = ToolbarWidth
        lH = ToolbarHeight
        GetWindowRect hWnd, tR
        GetWindowRect GetParent(hWnd), tPR
        GetClientRect GetParent(hWnd), tCR
        tP.X = tR.Left - tPR.Left - 2
        tP.Y = tR.Top - tPR.Top - 2
        SetWindowPos hWnd, 0, tP.X, tP.Y, lW, lH, SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOOWNERZORDER
     End If
End Sub

Private Property Get NewButtonID() As Long
   m_iID = m_iID + 1
   NewButtonID = m_iID
End Property

Public Property Let Left(mLeft As Long)
    Dim r As RECT
    Dim mTop As Long, mWidth As Long, mHeight As Long
    GetWindowRect hWnd, r
   ' mTop = r.Top
    mTop = 5
    mLeft = mLeft / mTwipsPerPixelX
    mHeight = r.Bottom - r.Top
    mWidth = r.Right - r.Left
    MoveWindow hWnd, mLeft, mTop, mWidth, mHeight, 1
End Property

Private Property Get ToolbarWidth() As Long
    Dim lSize As Long
    Dim lCount As Long
    Dim i As Long
    Dim rc As RECT
    lCount = SendMessageLong(hWnd, TB_BUTTONCOUNT, 0, 0)
    If (lCount > 0) Then
        For i = 0 To lCount - 1
            SendMessage hWnd, TB_GETITEMRECT, i, rc
            lSize = lSize + rc.Right - rc.Left
        Next i
        ToolbarWidth = lSize
    End If
End Property

Private Property Get ToolbarHeight() As Long
    Dim lCount As Long
    Dim i As Long
    Dim rc As RECT
    lCount = SendMessageLong(hWnd, TB_BUTTONCOUNT, 0, 0)
    If (lCount > 0) Then
        SendMessage hWnd, TB_GETITEMRECT, i, rc
        ToolbarHeight = rc.Bottom
    End If
End Property

Public Property Get Height() As Long
    Dim r As RECT
    GetWindowRect hWnd, r
    Height = (r.Bottom - r.Top) * mTwipsPerPixelY + 75
End Property

Private Function pbGetIndexForID(ByVal iBtnId As Long) As Long
    Dim iB As Long
    pbGetIndexForID = -1
    For iB = 0 To UBound(m_tBInfo)
        If (m_tBInfo(iB).wID = iBtnId) Then
            pbGetIndexForID = iB
            Exit For
        End If
    Next iB
End Function

Public Property Let DisabledImageList(hImageList As Long)
    SendMessageLong hWnd, TB_SETDISABLEDIMAGELIST, 0, hImageList
End Property

Public Sub iSubclass_After(lReturn As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
    Dim lhWNd As Long, hBr As Long
    Dim iB As Long
    Dim tR As RECT
    Dim tRO As RECT
    Dim tP As POINTAPI
    Dim lBtns As Long, iBtn As Long
    Dim tB As TBBUTTON
    Dim hdr As NMHDR
    Dim lTheme As Long
    If uMsg = WM_ERASEBKGND Then
        lhWNd = hWnd
        If GetParent(GetParent(GetParent(GetParent(hWnd)))) = gHW Then
            hBr = CreateSolidBrush(TranslateColor(frmMain.BackColor))
        Else
            If m_UseStyleXP Then
                lTheme = OpenThemeData(Me.hWnd, StrConv("TAB", vbUnicode))
                hBr = GetThemeSysColorBrush(lTheme, 4)
                CloseThemeData lTheme
            Else
                hBr = CreateSolidBrush(TranslateColor(frmMain.BackColor))
            End If
        End If
        GetWindowRect hWnd, tRO
        tRO.Left = 0
        tRO.Top = 0
        FillRect wParam, tRO, hBr
        DeleteObject hBr
    End If
    
End Sub

Private Sub iSubclass_Before(bHandled As Long, lReturn As Long, hWnd As Long, uMsg As Long, wParam As Long, lParam As Long)
    Dim iB As Long
    Dim tR As RECT
    Dim tRO As RECT
    Dim hBr As Long
    Dim tP As POINTAPI
    Dim lhWNd As Long
    Dim lBtns As Long, iBtn As Long
    Dim tB As TBBUTTON
    Dim hdr As NMHDR
    Dim ttt As ToolTipText
    If uMsg = WM_COMMAND Then
        If lParam = Me.hWnd Then
            iB = SendMessageLong(Me.hWnd, TB_COMMANDTOINDEX, wParam, 0)
            RaiseEvent ButtonClick(iB)
            bHandled = 1
        End If
    ElseIf uMsg = WM_NOTIFY Then
      CopyMemory hdr, ByVal lParam, Len(hdr)
      Select Case hdr.Code
        Case TTN_NEEDTEXTA, TTN_NEEDTEXTW
           Dim idNum As Integer
           idNum = hdr.idFrom
           On Error Resume Next
           
           iB = pbGetIndexForID(idNum)
           If (iB > -1) Then
              If hdr.Code = TTN_NEEDTEXTA Then
                    sToolTipBuffer = StrConv(m_tBInfo(iB).sTipText, vbFromUnicode)
              Else
                    sToolTipBuffer = m_tBInfo(iB).sTipText
              End If
              If Err.Number = 0 Then
                 If (Len(sToolTipBuffer) > 0) Then
                    sToolTipBuffer = sToolTipBuffer & vbNullChar
                    CopyMemory ttt, ByVal lParam, Len(ttt)
                    ttt.lpszText = StrPtr(sToolTipBuffer)
                    CopyMemory ByVal lParam, ttt, Len(ttt)
                    bHandled = 1
                 End If
              Else
                 Err.Clear
              End If
           End If
        End Select
    End If
End Sub
