VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFormatVB"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"


'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit

Public Enum OutputDevice
    OD_XHTML
    OD_RTF
    ' ...others
End Enum
    #If False Then
        Const OD_XHTML = 0
        Const OD_RTF = 1
    #End If
'----------------------------------------------------

' Members

Private m_OutputDevice      As OutputDevice
Private m_sKeywordList      As String
Private m_bReady            As Boolean
Private m_sBody             As String
' Formats
Private m_StyleNormal       As CStyleProps
Private m_StyleKeyword      As CStyleProps
Private m_StyleString       As CStyleProps
Private m_StyleComment      As CStyleProps

' Tags
Private m_TagKeyword        As String
Private m_TagString         As String
Private m_TagComment        As String
Private m_TagEndTag         As String
'----------------------------------------------------

' Constants

Private Const XHTML_KEYWORD As String = "<span class=""keyword"">"
Private Const XHTML_STRING  As String = "<span class=""string"">"
Private Const XHTML_COMMENT As String = "<span class=""comment"">"
Private Const XHTML_ENDTAG  As String = "</span>"
'----------------------------------------------------

' Class Constructor/Destructor

Private Sub Class_Initialize()
    m_OutputDevice = OD_XHTML
    
    Call SetKeywordList
    
    Set m_StyleNormal = New CStyleProps
    Set m_StyleKeyword = New CStyleProps
    Set m_StyleString = New CStyleProps
    Set m_StyleComment = New CStyleProps
End Sub

Private Sub Class_Terminate()
    Set m_StyleNormal = Nothing
    Set m_StyleKeyword = Nothing
    Set m_StyleString = Nothing
    Set m_StyleComment = Nothing
End Sub
'----------------------------------------------------

' Properties

Public Property Get OutputDevice() As OutputDevice
    OutputDevice = m_OutputDevice
End Property
Public Property Let OutputDevice(Value As OutputDevice)
    m_OutputDevice = Value
End Property

Public Property Get KeywordList() As String
    KeywordList = m_sKeywordList
End Property
Public Property Let KeywordList(Value As String)
    m_sKeywordList = Value
End Property

Public Property Get Style_Normal() As CStyleProps
    Set Style_Normal = m_StyleNormal
End Property

Public Property Get Style_Keywords() As CStyleProps
    Set Style_Keywords = m_StyleKeyword
End Property

Public Property Get Style_String() As CStyleProps
    Set Style_String = m_StyleString
End Property

Public Property Get Style_Comments() As CStyleProps
    Set Style_Comments = m_StyleComment
End Property

'----------------------------------------------------

' Public Member Functions

Public Sub FixOptions()
    Select Case m_OutputDevice
        Case OD_XHTML
            Call PrepareXHTMLHeader
            m_TagKeyword = XHTML_KEYWORD
            m_TagString = XHTML_STRING
            m_TagComment = XHTML_COMMENT
            m_TagEndTag = XHTML_ENDTAG
        Case OD_RTF
            Call PrepareRTFHeader
    End Select
    
    m_bReady = True
End Sub

Public Sub LooseOptions()
    m_bReady = False
    
    Set m_StyleNormal = New CStyleProps
    Set m_StyleKeyword = New CStyleProps
    Set m_StyleString = New CStyleProps
    Set m_StyleComment = New CStyleProps
End Sub

Public Function Parse( _
  ByVal Code As String _
) As String
    Dim I       As Long, _
        J       As Long, _
        k       As Long
    Dim Lines() As String, _
        Parts() As String
    Dim RemPos  As Long
    Dim Trimmed As String
    Dim EndLine As String
    Dim Result  As CStringBuilder
    '------------------------------------------------
    
    ' no code
    If LenB(Code) = 0 Then _
        Exit Function
    
    ' no keyword list or options not fixed
    If Not (CBool(LenB(m_sKeywordList)) And m_bReady) Then _
        Exit Function
    
    '------------------------------------------------
    ' do formatting
    
    Select Case m_OutputDevice
        Case OD_XHTML
            Code = HTMLEncode(Code)
        Case OD_RTF
            Code = RTFEncode(Code)
            EndLine = "\par"
    End Select ' m_OutputDevice
    
    Lines = Split(Code, vbCrLf)
    If UBound(Lines) = 0 Then
        ' Test other line breaks.
        If InStrB(1, Code, vbCr) > 0 Then
            Lines = Split(Code, vbCr)
        ElseIf InStrB(1, Code, vbLf) > 0 Then
            Lines = Split(Code, vbLf)
        End If
    End If
    
    Set Result = New CStringBuilder
    
    For I = 0 To UBound(Lines)
        Trimmed = Trim$(Lines(I))
        
        If LenB(Trimmed) Then
            If LeftB$(Trimmed, 2) = "'" Or _
                InStrB(Trimmed, "Rem ") = 1 _
            Then
                Call Result.Append(m_TagComment)
                Call Result.Append(Lines(I))
                Call Result.Append(m_TagEndTag)
            Else
                Parts = Split(Lines(I), """")
                
                RemPos = 0
                
                For J = 0 To UBound(Parts)
                    If LenB(Parts(J)) Then
                        If (J Mod 2) Then
                            Call Result.Append(m_TagString)
                            Call Result.Append("""")
                            Call Result.Append(Parts(J))
                            Call Result.Append("""")
                            Call Result.Append(m_TagEndTag)
                        Else
                            RemPos = InStrB(Parts(J), "'")
                            
                            If RemPos Then
                                Call Result.Append( _
                                    FormatLine(MidB$(Parts(J), 1, RemPos - 1)) _
                                )
                                Call Result.Append(m_TagComment)
                                Call Result.Append( _
                                    MidB$(Parts(J), RemPos, LenB(Parts(J)) - RemPos + 2) _
                                )
                                
                                For k = J + 1 To UBound(Parts)
                                    Call Result.Append("""")
                                    Call Result.Append(Parts(k))
                                Next
                                
                                Call Result.Append(m_TagEndTag)
                                Exit For
                            Else
                                Call Result.Append(FormatLine(Parts(J)))
                            End If
                        End If
                    Else
                        If (J Mod 2) Then _
                            Call Result.Append(m_TagString): _
                            Call Result.Append(""""""): _
                            Call Result.Append(m_TagEndTag)
                    End If
                Next J
                
                RemPos = 0
            End If
        End If
        
        Call Result.AppendLine(EndLine)
    Next I
    
    Parse = Replace(m_sBody, "%CODE_INCLUDE%", Result.ToString())
End Function
'----------------------------------------------------

' Private Member Functions

Private Sub SetKeywordList()
    Dim KeyData() As Byte
    KeyData = LoadResData("Keywords", "DATA")
    m_sKeywordList = StrConv(KeyData, vbUnicode)
End Sub

Private Function FormatLine(Content As String) As String
    Dim Words1()    As String, _
        Words2()    As String, _
        Words3()    As String, _
        Words4()    As String
    Dim I           As Long, _
        J           As Long, _
        k           As Long, _
        l           As Long
    
    ' four loops are needed to split text
    ' to eleminate all delimiters that can touch a keyword:
    ' " ", "(", ")", ","
    Words1 = Split(Content, " ")
    
    For I = 0 To UBound(Words1)
        If LenB(Words1(I)) Then
            Words2 = Split(Words1(I), "(")
            
            For J = 0 To UBound(Words2)
                If LenB(Words2(J)) Then
                    Words3 = Split(Words2(J), ")")
                    
                    For k = 0 To UBound(Words3)
                        If LenB(Words3(k)) Then
                            Words4 = Split(Words3(k), ",")
                            
                            For l = 0 To UBound(Words4)
                                If InStrB(m_sKeywordList, "|" & Words4(l) & "|") Then _
                                    Words4(l) = m_TagKeyword & Words4(l) & m_TagEndTag
                            Next l
                            
                            Words3(k) = Join(Words4, ",")
                        End If
                    Next k
                    
                    Words2(J) = Join(Words3, ")")
                End If
            Next J
            
            Words1(I) = Join(Words2, "(")
        End If
    Next I
    
    FormatLine = Join(Words1, " ")
End Function

Private Sub PrepareXHTMLHeader()
    Const SPACER    As String = "    "
    Const SPACER2   As String = SPACER & SPACER
    Const SPACER3   As String = SPACER2 & SPACER
    
    Dim Style       As String
    Dim Font        As String
'FIXIT: 'ExtStyle' mit einem Datentyp mit frher Bindung deklarieren                       FixIT90210ae-R1672-R1B8ZE
    Dim ExtStyle    As Variant
    '------------------------------------------------
    
    ' create XHTML file body
    m_sBody = "<!DOCTYPE html PUBLIC " & _
                """-//W3C//DTD XHTML 1.0 Strict//EN"" " & _
                """http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"">" & _
                vbCrLf & _
                "<html xmlns=""http://www.w3.org/1999/xhtml"">" & vbCrLf & _
                "<head>" & vbCrLf & _
                "    <title>VB Code</title>" & vbCrLf & _
                "    <meta content=""Mad Rat Pro. CFormatVB class"" " & _
                "name=""generator"" />" & vbCrLf & _
                "    <style type=""text/css"">" & vbCrLf & _
                "    <!--" & vbCrLf & _
                "%STYLE_INCLUDE%" & vbCrLf & _
                "    -->" & vbCrLf & _
                "    </style>" & vbCrLf & _
                "</head>" & vbCrLf & _
                "<body>" & vbCrLf & _
                "<pre>" & vbCrLf & _
                "%CODE_INCLUDE%" & vbCrLf & _
                "</pre>" & vbCrLf & _
                "</body>" & vbCrLf & _
                "</html>"
    
    '------------------------------------------------
    ' Normal text
    Style = SPACER2 & "body, pre {" & vbCrLf
    
    With m_StyleNormal
        Style = Style & SPACER3 & "background: " & _
                ColHTML(.BackColor) & ";" & vbCrLf
        Style = Style & SPACER3 & "color: " & _
                ColHTML(.ForeColor) & ";" & vbCrLf
        
        With .Font
            Font = SPACER3 & "font:"
            
            If .Italic Then _
                Font = Font & " italic"
            If .Bold Then _
                Font = Font & " bold"
            
            Font = Font & " " & CStr(CLng(.Size)) & "pt"
            Font = Font & " """ & .name & """" & ";"
            
            Style = Style & Font & vbCrLf
            
            Font = ""
            
            If .Strikethrough Then _
                Font = Font & " line-through"
            If .Underline Then _
                Font = Font & " underline"
            
            If CBool(LenB(Font)) Then
                Font = SPACER3 & "text-decoration:" & Font & ";"
                Style = Style & Font & vbCrLf
            End If ' CBool(LenB(Font))
        End With ' .Font
        
        If CBool(.Extended.Count) Then
            For Each ExtStyle In .Extended
                Style = Style & SPACER3 & CStr(ExtStyle) & ";" & vbCrLf
            Next ExtStyle
        End If ' CBool(.Extended.Count)
    End With ' m_StyleNormal
    
    Style = Style & SPACER2 & "}" & vbCrLf

    '------------------------------------------------
    ' Keywords
    Style = Style & SPACER2 & "pre .keyword {" & vbCrLf
    
    With m_StyleKeyword
        Style = Style & SPACER3 & "background: " & _
                ColHTML(.BackColor) & ";" & vbCrLf
        Style = Style & SPACER3 & "color: " & _
                ColHTML(.ForeColor) & ";" & vbCrLf
        
        With .Font
            Font = SPACER3 & "font:"
            
            If .Italic Then _
                Font = Font & " italic"
            If .Bold Then _
                Font = Font & " bold"
            
            Font = Font & " " & CStr(CLng(.Size)) & "pt"
            Font = Font & " """ & .name & """" & ";"
            
            Style = Style & Font & vbCrLf
            
            Font = ""
            
            If .Strikethrough Then _
                Font = Font & " line-through"
            If .Underline Then _
                Font = Font & " underline"
            
            If CBool(LenB(Font)) Then
                Font = SPACER3 & "text-decoration:" & Font & ";"
                Style = Style & Font & vbCrLf
            End If ' CBool(LenB(Font))
        End With ' .Font
        
        If CBool(.Extended.Count) Then
            For Each ExtStyle In .Extended
                Style = Style & SPACER3 & CStr(ExtStyle) & ";" & vbCrLf
            Next ExtStyle
        End If ' CBool(.Extended.Count)
    End With ' m_StyleKeyword
    
    Style = Style & SPACER2 & "}" & vbCrLf

    '------------------------------------------------
    ' Strings
    Style = Style & SPACER2 & "pre .string {" & vbCrLf
    
    With m_StyleString
        Style = Style & SPACER3 & "background: " & _
                ColHTML(.BackColor) & ";" & vbCrLf
        Style = Style & SPACER3 & "color: " & _
                ColHTML(.ForeColor) & ";" & vbCrLf
        
        With .Font
            Font = SPACER3 & "font:"
            
            If .Italic Then _
                Font = Font & " italic"
            If .Bold Then _
                Font = Font & " bold"
            
            Font = Font & " " & CStr(CLng(.Size)) & "pt"
            Font = Font & " """ & .name & """" & ";"
            
            Style = Style & Font & vbCrLf
            
            Font = ""
            
            If .Strikethrough Then _
                Font = Font & " line-through"
            If .Underline Then _
                Font = Font & " underline"
            
            If CBool(LenB(Font)) Then
                Font = SPACER3 & "text-decoration:" & Font & ";"
                Style = Style & Font & vbCrLf
            End If ' CBool(LenB(Font))
        End With ' .Font
        
        If CBool(.Extended.Count) Then
            For Each ExtStyle In .Extended
                Style = Style & SPACER3 & CStr(ExtStyle) & ";" & vbCrLf
            Next ExtStyle
        End If ' CBool(.Extended.Count)
    End With ' m_StyleString
    
    Style = Style & SPACER2 & "}" & vbCrLf

    '------------------------------------------------
    ' Comments
    Style = Style & SPACER2 & "pre .comment {" & vbCrLf
    
    With m_StyleComment
        Style = Style & SPACER3 & "background: " & _
                ColHTML(.BackColor) & ";" & vbCrLf
        Style = Style & SPACER3 & "color: " & _
                ColHTML(.ForeColor) & ";" & vbCrLf
        
        With .Font
            Font = SPACER3 & "font:"
            
            If .Italic Then _
                Font = Font & " italic"
            If .Bold Then _
                Font = Font & " bold"
            
            Font = Font & " " & CStr(CLng(.Size)) & "pt"
            Font = Font & " """ & .name & """" & ";"
            
            Style = Style & Font & vbCrLf
            
            Font = ""
            
            If .Strikethrough Then _
                Font = Font & " line-through"
            If .Underline Then _
                Font = Font & " underline"
            
            If CBool(LenB(Font)) Then
                Font = SPACER3 & "text-decoration:" & Font & ";"
                Style = Style & Font & vbCrLf
            End If ' CBool(LenB(Font))
        End With ' .Font
        
        If CBool(.Extended.Count) Then
            For Each ExtStyle In .Extended
                Style = Style & SPACER3 & CStr(ExtStyle) & ";" & vbCrLf
            Next ExtStyle
        End If ' CBool(.Extended.Count)
    End With ' m_StyleComment
    
    Style = Style & SPACER2 & "}"
    
    m_sBody = Replace(m_sBody, "%STYLE_INCLUDE%", Style)
End Sub

Private Sub PrepareRTFHeader()
    Dim Style       As String
    Dim Fonts       As String
    Dim Colors      As String
    '------------------------------------------------
    
    m_sBody = "{\rtf1\ansi\deff0%STYLE_INCLUDE%" & _
              "\viewkind4\uc1\pard\lang1031\fs20 %STYLE%%CODE_INCLUDE%}"
    
    '------------------------------------------------
    ' Normal text
    
    Fonts = "{\fonttbl"
    Colors = "{\colortbl ;"
    
    With m_StyleNormal
        With .Font
            Fonts = Fonts & "{\f0\fnil\fcharset" & CStr(.Charset) & _
                    " " & .name & ";}"
        End With ' .Font
        Colors = Colors & ColRTF(.BackColor) & ColRTF(.ForeColor)
        
        m_TagEndTag = "\f0\cb1\cf2"
        
        If .Font.Bold Then _
            m_TagEndTag = m_TagEndTag & "\b" _
        Else _
            m_TagEndTag = m_TagEndTag & "\b0"
        If .Font.Italic Then _
            m_TagEndTag = m_TagEndTag & "\i" _
        Else _
            m_TagEndTag = m_TagEndTag & "\i0"
        If .Font.Underline Then _
            m_TagEndTag = m_TagEndTag & "\ul " _
        Else _
            m_TagEndTag = m_TagEndTag & "\ulnone "
    End With ' m_StyleNormal
    
    With m_StyleKeyword
        With .Font
            Fonts = Fonts & "{\f1\fnil\fcharset" & CStr(.Charset) & _
                    " " & .name & ";}"
        End With ' .Font
        Colors = Colors & ColRTF(.BackColor) & ColRTF(.ForeColor)
        
        m_TagKeyword = "\f1\cb3\cf4"
        
        If .Font.Bold Then _
            m_TagKeyword = m_TagKeyword & "\b" _
        Else _
            m_TagKeyword = m_TagKeyword & "\b0"
        If .Font.Italic Then _
            m_TagKeyword = m_TagKeyword & "\i" _
        Else _
            m_TagKeyword = m_TagKeyword & "\i0"
        If .Font.Underline Then _
            m_TagKeyword = m_TagKeyword & "\ul " _
        Else _
            m_TagKeyword = m_TagKeyword & "\ulnone "
    End With ' m_StyleKeyword
    
    With m_StyleString
        With .Font
            Fonts = Fonts & "{\f2\fnil\fcharset" & CStr(.Charset) & _
                    " " & .name & ";}"
        End With ' .Font
        Colors = Colors & ColRTF(.BackColor) & ColRTF(.ForeColor)
        
        m_TagString = "\f2\cb5\cf6"
        
        If .Font.Bold Then _
            m_TagString = m_TagString & "\b" _
        Else _
            m_TagString = m_TagString & "\b0"
        If .Font.Italic Then _
            m_TagString = m_TagString & "\i" _
        Else _
            m_TagString = m_TagString & "\i0"
        If .Font.Underline Then _
            m_TagString = m_TagString & "\ul " _
        Else _
            m_TagString = m_TagString & "\ulnone "
    End With ' m_StyleString
    
    With m_StyleComment
        With .Font
            Fonts = Fonts & "{\f3\fnil\fcharset" & CStr(.Charset) & _
                    " " & .name & ";}"
        End With ' .Font
        Colors = Colors & ColRTF(.BackColor) & ColRTF(.ForeColor)
        
        m_TagComment = "\f3\cb7\cf8"
        
        If .Font.Bold Then _
            m_TagComment = m_TagComment & "\b" _
        Else _
            m_TagComment = m_TagComment & "\b0"
        If .Font.Italic Then _
            m_TagComment = m_TagComment & "\i" _
        Else _
            m_TagComment = m_TagComment & "\i0"
        If .Font.Underline Then _
            m_TagComment = m_TagComment & "\ul " _
        Else _
            m_TagComment = m_TagComment & "\ulnone "
    End With ' m_StyleComment
    
    ' ...
    Fonts = Fonts & "}"
    Colors = Colors & "}"
    Style = Fonts & Colors
    
    m_sBody = Replace(m_sBody, "%STYLE_INCLUDE%", Style)
    m_sBody = Replace(m_sBody, "%STYLE%", m_TagEndTag)
End Sub

Private Function ColHTML(Color As OLE_COLOR) As String
    ColHTML = Right$("00000" & Hex$(Color), 6)

    ColHTML = "#" & _
              Mid$(ColHTML, 5, 2) & _
              Mid$(ColHTML, 3, 2) & _
              Mid$(ColHTML, 1, 2)
End Function

Private Function ColRTF(Color As OLE_COLOR) As String
    ColRTF = "\red" & CStr(Color And vbRed) & _
             "\green" & CStr((Color And vbGreen) \ &H100) & _
             "\blue" & CStr((Color And vbBlue) \ &H10000) & _
             ";"
End Function

Private Function HTMLEncode( _
  Text As String _
) As String
    Dim I       As Long
    Dim Ascii   As Long
    
    HTMLEncode = Text
    
    If CBool(InStrB(HTMLEncode, "&")) Then _
        HTMLEncode = Replace(HTMLEncode, "&", "&amp;")
    If CBool(InStrB(HTMLEncode, "<")) Then _
        HTMLEncode = Replace(HTMLEncode, "<", "&lt;")
    If CBool(InStrB(HTMLEncode, ">")) Then _
        HTMLEncode = Replace(HTMLEncode, ">", "&gt;")
    
    ' replace special chars by ANSI value
    For I = 1 To LenB(Text) Step 2
        Ascii = AscB(MidB$(HTMLEncode, I, 2))
        
        If Ascii >= 160 Then
            HTMLEncode = LeftB$(HTMLEncode, I - 1) & _
                         "&#" & CStr(Ascii) & ";" & _
                         MidB$(HTMLEncode, I + 2)
        End If
    Next I
End Function

Private Function RTFEncode( _
  Text As String _
) As String
    RTFEncode = Text
    
    If CBool(InStrB(RTFEncode, "\")) Then _
        RTFEncode = Replace(RTFEncode, "\", "\\")
    If CBool(InStrB(RTFEncode, "{")) Then _
        RTFEncode = Replace(RTFEncode, "{", "\{")
    If CBool(InStrB(RTFEncode, "}")) Then _
        RTFEncode = Replace(RTFEncode, "}", "\}")
End Function
'----------------------------------------------------
