VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CIni"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const MAX_PATH As Long = 260

Public Enum SHELLFOLDERS
    CSIDL_DESKTOP = &H0&            ' ..\WinNT\profiles\username\Desktop
    CSIDL_PROGRAMS = &H2&           ' ..\WinNT\profiles\username\Start Menu\Programs
    CSIDL_CONTROLS = &H3&
    CSIDL_PRINTERS = &H4&
    CSIDL_PERSONAL = &H5&           ' ..\WinNT\profiles\username\Personal
    CSIDL_FAVORITES = &H6&          ' ..\WinNT\profiles\username\Favorites
    CSIDL_STARTUP = &H7&            ' ..\WinNT\profiles\username\Start Menu\Programs\Startup
    CSIDL_RECENT = &H8&             ' ..\WinNT\profiles\username\Recent
    CSIDL_SENDTO = &H9&             ' ..\WinNT\profiles\username\SendTo
    CSIDL_BITBUCKET = &HA&
    CSIDL_STARTMENU = &HB&          ' ..\WinNT\profiles\username\Start Menu
    CSIDL_DESKTOPDIRECTORY = &H10&  ' ..\WinNT\profiles\username\Desktop
    CSIDL_DRIVES = &H11&
    CSIDL_NETWORK = &H12&
    CSIDL_NETHOOD = &H13&           ' ..\WinNT\profiles\username\NetHood
    CSIDL_FONTS = &H14&             ' ..\WinNT\fonts
    CSIDL_TEMPLATES = &H15&         ' ..\WinNT\ShellNew
    CSIDL_COMMON_STARTMENU = &H16&  ' ..\WinNT\profiles\All Users\Start Menu
    CSIDL_COMMON_PROGRAMS = &H17&   ' ..\WinNT\profiles\All Users\Start Menu\Programs
    CSIDL_COMMON_STARTUP = &H18&    ' ..\WinNT\profiles\All Users\Start Menu\Programs\Startup
    CSIDL_COMMON_DESKTOPDIRECTORY = &H19& '..\WinNT\profiles\All Users\Desktop
    CSIDL_APPDATA = &H1A&           ' ..\WinNT\profiles\username\Application Data
    CSIDL_PRINTHOOD = &H1B&         ' ..\WinNT\profiles\username\PrintHood
End Enum

Private Declare Function GetPrivateProfileStringA Lib "kernel32.dll" ( _
    ByVal lpSection As String, ByVal lpSetting As String, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, _
    ByVal lpFileName As String) As Long

Private Declare Function GetPrivateProfileStringW Lib "kernel32.dll" ( _
    ByVal lpSection As Long, ByVal lpSetting As Long, ByVal lpDefault As Long, _
    ByVal lpReturnedString As Long, ByVal nSize As Long, _
    ByVal lpFileName As Long) As Long

Private Declare Function WritePrivateProfileStringA Lib "kernel32.dll" ( _
    ByVal lpSection As String, ByVal lpSetting As String, ByVal lpValue As String, _
    ByVal lpFileName As String) As Long

Private Declare Function WritePrivateProfileStringW Lib "kernel32.dll" ( _
    ByVal lpSection As Long, ByVal lpSetting As Long, ByVal lpValue As Long, _
    ByVal lpFileName As Long) As Long

Private Declare Function SHGetPathFromIDListW Lib "shell32" (ByVal pidl As Long, _
    ByVal szPath As Long) As Long

Private Declare Function SHGetPathFromIDList Lib "shell32" Alias _
    "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal szPath As String) As Long

Private Declare Function SHGetSpecialFolderLocation Lib "shell32" ( _
    ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long

Private m_IniPath   As String
Private m_UserPath  As String
Private m_FilePath  As String
'----------------------------------------------------

Private Sub Class_Initialize()
    'INI Pfad ermitteln
    Call GetSystemFolderPath(0, CSIDL_APPDATA, m_UserPath)
    m_UserPath = IIf(Right$(m_UserPath, 1) = "\", m_UserPath, m_UserPath & "\") & "ActiveVB\Messenger\"
    Call MakeSureDirectoryPathExists(m_UserPath)
    m_IniPath = IIf(Right$(m_UserPath, 1) = "\", m_UserPath, m_UserPath & "\") & "settings.ini"
    
    'Pfad fr eingehende Dateien ermitteln
    Call GetSystemFolderPath(0, CSIDL_PERSONAL, m_FilePath)
    m_FilePath = IIf(Right$(m_FilePath, 1) = "\", m_FilePath, m_FilePath & "\") & "Meine empfangenen Dateien\"
    Call MakeSureDirectoryPathExists(m_FilePath)
    
End Sub
'----------------------------------------------------

Private Function GetSystemFolderPath(ByVal hwnd As Long, ByVal ID As SHELLFOLDERS, sfPath As String) As Long
    Dim rc As Long
    Dim pidl As Long
    Dim cbPath As Long
    Dim szPath As String
    szPath = Space(MAX_PATH)
    rc = SHGetSpecialFolderLocation(hwnd, CInt(ID), pidl)
    If (rc = 0) Then
        If IsUnicodeSupported Then
            rc = SHGetPathFromIDListW(pidl, StrPtr(szPath))
        Else
            rc = SHGetPathFromIDList(pidl, szPath)
        End If
        If (rc = 1) Then
            szPath = Trim$(szPath)
            cbPath = Len(szPath)
            If (Asc(Right$(szPath, 1)) = 0) Then cbPath = cbPath - 1
            If (cbPath > 0) Then sfPath = Left$(szPath, cbPath)
            GetSystemFolderPath = True
        End If
    End If
End Function

Public Property Get IniPath() As String
    IniPath = m_IniPath
End Property

Public Property Let IniPath(RHS As String)
    m_IniPath = RHS
End Property

Public Property Get UserPath() As String
    UserPath = m_UserPath
End Property

Public Property Get FileTransferPath() As String
    FileTransferPath = m_FilePath
End Property

Public Function IniRead( _
  ByRef Section As String, _
  ByRef Key As String, _
  Optional ByRef Default As String _
) As String
    Dim s As String
    Dim n As Long
    Dim strLen As Long
    
    Do
        strLen = strLen + 100
        s = Space$(strLen)
        
        If IsUnicodeSupported() Then
            n = GetPrivateProfileStringW(StringPtr(Section), StringPtr(Key), StringPtr(Default), StringPtr(s), strLen, StringPtr(m_IniPath))
        Else
            n = GetPrivateProfileStringA(Section, Key, Default, s, strLen, m_IniPath)
        End If
    Loop While n = strLen - 1
    
    IniRead = Left$(s, n)
End Function

Public Sub IniWrite( _
  ByRef Section As String, _
  ByRef Key As String, _
  ByRef Value As String _
)
    Dim n As Long
    
    If IsUnicodeSupported Then
        n = WritePrivateProfileStringW(StringPtr(Section), StringPtr(Key), StringPtr(Value), StringPtr(m_IniPath))
    Else
        n = WritePrivateProfileStringA(Section, Key, Value, m_IniPath)
    End If
    
    If n = 0 Then _
        Call Err.Raise(5) 'Invalid procedure call or argument
End Sub
