VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLogin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************************
'*      Die Loginklasse der Klassenkombination
'*
'*      Diese Klasse darf nicht instanziert werden!!!!
'*      Der Klassenname darf nicht verndert werden!!!
'*
'*      Erstellt fr ActiveVB Instant Messenger
'*      (c) 2003 Kai Liebenau
'*      Version: V 0.8.8
'*
'*  History:
'*
'*  Ver 0.8.8   - In Work
'*              - Datacontainer eingebaut
'*              - Errorhandling bei Aufruf von API_Connect gendert
'*              - Errorhandling bei Aufruf von API_SocketSend gendert
'*              - Errorhandling bei Resolve Hostname gendert
'*              - TimeOut bei Connect eingefhrt, falls alle anderen Timeouts versagen
'*  Ver 0.8.7   - Nothing
'*  Ver 0.8.6   - Nothing
'*  Ver 0.8.5   - Nothing
'*  Ver 0.8.4   - Nothing
'*  Ver 0.8.3   - Nothing
'*  Ver 0.8.2   - Nothing
'*  Ver 0.8.1   - Implementierung der Schnittstelle ISocket
'******************************************************************************

Option Explicit

Private WithEvents SocketWindow As clsSocketWindow    'Socketfensterobjekt
Attribute SocketWindow.VB_VarHelpID = -1
'Private fMainForm               As Form         'Referenzobjekt zur Form auf dem das Socketfenster liegt
Private objClassReferenz        As ISocket      'Referenzobjekt zur Managementklasse

Dim c_HWndtoMsg                 As Long         'Fensterhandle zum Socketwindow
Dim c_Socket                    As Long         'Sockethandle
'Dim c_strRemoteIP               As String       'IP Addresse des RemoteHost

Dim strData                     As String       'Daten Zwischenspeicher
Dim bolDataRecived              As Boolean      'wurden Daten empfangen
Dim clsLogin_SocketsError       As Boolean      'Socketerror aufgetreten
Dim clsLogin_Connected          As Boolean      'ist der Host connected
Dim c_lngMSG_ID                 As Long
Dim c_LastWSAEventError         As Long

Public Sub clsLogin_SetReferenz(ByRef objClassRef As ISocket)
'Objekt Referenz setzen
Set objClassReferenz = objClassRef
End Sub
Private Sub CreateSocketWindow()
'Set fMainForm = dlgSocketWindow
On Error Resume Next
'fMainForm.Controls.Add "VB.PictureBox", "picLoginSocketWindow", fMainForm
'If Err.Number Then objClassReferenz.SocketLog "Login, Can't create Socketwindow: " & Err.Description, SOCKETLOG_ERROR_EX
'Set SocketWindow = fMainForm.Controls("picLoginSocketWindow")
If c_HWndtoMsg = 0 Then c_HWndtoMsg = SocketWindow.CreateWindowAndHook 'hwnd
If c_HWndtoMsg = 0 Then objClassReferenz.SocketLog "Login, Can't create Socketwindow: " & Err.Description, -1, SOCKETLOG_ERROR_EX
End Sub
Public Function clsLogin_SendData(DataContainer As clsLoginData) As Boolean
Dim lngTimeOut As Long, lngIP As Long, SocketBuffer As SockAddr
Dim strHost As String, lngPort As Long, strSendData As String
Dim lWSAError As Long, tTime As Date

On Error Resume Next

'c_strRemoteIP = strDest

'Besteht schon eine Verbindung?
If c_Socket = INVALID_SOCKET Then
    'Socket erstellen
    c_Socket = socket(AF_INET, SOCK_STREAM, 0)
    If c_Socket = INVALID_SOCKET Then 'Wenn kein Socket erstellt werden konnte
        lWSAError = WSAGetLastError
        objClassReferenz.SocketLog "Login, Can't Create Socket " & GetWSAErrorString(lWSAError), -1, SOCKETLOG_ERROR_EX
        Call DataContainer.SetError(lWSAError, "Can't Create Socket, " & GetWSAErrorString(lWSAError))
        Exit Function
    End If
    If m_ProxyEnabled = True Then
        strHost = m_ProxyServer
        lngPort = m_ProxyPort
    Else
        strHost = AVB_SITE
        lngPort = HTTP_PORT
    End If
    lngIP = GetHostByNameAlias(strHost, lWSAError)
    If lngIP = -1 Then 'IP konnte nicht ermittelt werden
        objClassReferenz.SocketLog "Login, Can't Resolve Hostname " & strHost & ", " & GetWSAErrorString(lWSAError), -1, SOCKETLOG_ERROR
        Call DataContainer.SetError(lWSAError, "Can't resolve hostname '" & strHost & "'" & vbCrLf & GetWSAErrorString(lWSAError))
        Call API_CloseSocket(c_Socket)
        c_Socket = INVALID_SOCKET
        Exit Function
    End If
    'Socketaddresse einstellen
    SocketBuffer.sin_port = htons(lngPort)
    SocketBuffer.sin_family = AF_INET
    SocketBuffer.sin_addr = lngIP
    SocketBuffer.sin_zero = String$(8, 0)
    
    If c_HWndtoMsg <> 0 Then
        objClassReferenz.SocketLog "Login, Socketwindow is exsist!", -1, SOCKETLOG_WARNING
    Else
        Call CreateSocketWindow
    End If
    If c_HWndtoMsg = 0 Then
        objClassReferenz.SocketLog "Login, Socketwindow Hwnd is NULL!!", -1, SOCKETLOG_ERROR
        Call DataContainer.SetError(vbObjectError, "Kann Window nicht erstellen!")
        Call API_CloseSocket(c_Socket)
        c_Socket = INVALID_SOCKET
        Exit Function
    End If
    
    If WSAAsyncSelect(c_Socket, c_HWndtoMsg, c_lngMSG_ID, FD_CONNECT) <> SOCKET_ERROR Then
        'Host connecten
        If API_Connect(c_Socket, SocketBuffer, Len(SocketBuffer)) = SOCKET_ERROR Then
            If Err.LastDllError <> WSAEWOULDBLOCK Then 'ConnectError ?
                objClassReferenz.SocketLog "Login Connect, " & GetWSAErrorString(Err.LastDllError), -1, SOCKETLOG_ERROR_EX
                Call DataContainer.SetError(Err.LastDllError, GetWSAErrorString(Err.LastDllError))
                Call API_CloseSocket(c_Socket)
                c_Socket = INVALID_SOCKET
                Exit Function
            End If
        End If
    Else
        lWSAError = WSAGetLastError
        objClassReferenz.SocketLog "Login, SocketConnect can't Set NonBlockingMode " & GetWSAErrorString(lWSAError), -1, SOCKETLOG_ERROR_EX
        Call DataContainer.SetError(lWSAError, GetWSAErrorString(lWSAError))
        Call API_CloseSocket(c_Socket)
        c_Socket = INVALID_SOCKET
        Exit Function
    End If
    'warten das die Connection zum Host aufgebaut ist
    tTime = Now
    Do While clsLogin_Connected = False And clsLogin_SocketsError = False
        DoEvents
        Sleep 100
        If DateDiff("s", tTime, Now) > TIMEOUT_CONNECT + 10 Then clsLogin_SocketsError = True: Exit Do
    Loop
    'Wenn beim connecten ein Fehler aufgetreten ist
    If clsLogin_SocketsError = True Then
        If c_LastWSAEventError = 0 Then c_LastWSAEventError = 10060
        objClassReferenz.SocketLog "Login, Connection faild: " & GetWSAErrorString(c_LastWSAEventError), -1, SOCKETLOG_ERROR_EX
        Call DataContainer.SetError(c_LastWSAEventError, GetWSAErrorString(c_LastWSAEventError))
        Call API_CloseSocket(c_Socket)
        Exit Function
    End If
End If

If c_Socket Then 'existiert ein Socket
    'WindowsMessages bei Events erzeugen lassen
    If WSAAsyncSelect(c_Socket, c_HWndtoMsg, c_lngMSG_ID, FD_CLOSE Or FD_READ Or FD_Write) = SOCKET_ERROR Then
        lWSAError = WSAGetLastError
        objClassReferenz.SocketLog "Login, SendData can't set NonBlockingMode " & GetWSAErrorString(WSAGetLastError), -1, SOCKETLOG_ERROR_EX
        Call DataContainer.SetError(WSAGetLastError, GetWSAErrorString(WSAGetLastError))
        Call API_CloseSocket(c_Socket)
        c_Socket = INVALID_SOCKET
        Exit Function
    End If
    'Nix wie wech mit den Daten
    DataContainer.LanIP = LocalUser.cpLAN_IP
    If DataContainer.IsDataOK Then
        strSendData = DataContainer.GetHTTPHeader
        'If Len(strSendData) = 0 Then Exit Function
        If API_SocketSend(c_Socket, ByVal strSendData, Len(strSendData), 0) = SOCKET_ERROR Then
            If Err.LastDllError <> WSAEWOULDBLOCK Then
                objClassReferenz.SocketLog "Login, SendData faild " & GetWSAErrorString(Err.LastDllError), -1, SOCKETLOG_ERROR_EX
                Call DataContainer.SetError(Err.LastDllError, GetWSAErrorString(Err.LastDllError))
                Call API_ShutDown(c_Socket, SD_BOTH)
                Call API_CloseSocket(c_Socket)
                c_Socket = INVALID_SOCKET
                Exit Function
            End If
        End If
        'Auf Antwort warten
        Do
            DoEvents
            Call Sleep(100)
            lngTimeOut = lngTimeOut + 1
            If lngTimeOut > TIMEOUT Then Exit Do
        Loop While bolDataRecived = False
        
        If bolDataRecived = False Or (lngTimeOut > TIMEOUT) Then
            objClassReferenz.SocketLog "Login, Wait for RecivedData faild " & GetWSAErrorString(WSAGetLastError), -1, SOCKETLOG_WARNING_EX
            If c_LastWSAEventError Then
                Call DataContainer.SetError(c_LastWSAEventError, GetWSAErrorString(c_LastWSAEventError))
            Else
                Call DataContainer.SetError(vbObjectError, "Can't recive the response message.")
            End If
            Call API_ShutDown(c_Socket, SD_BOTH)
            Call API_CloseSocket(c_Socket)
            c_Socket = INVALID_SOCKET
            Exit Function
        End If
        'Dann nichts wie raus hier und die Daten zurck
        DataContainer.Response = strData
        clsLogin_SendData = True
        Debug.Print strData
    Else
        Call DataContainer.SetError(vbObjectError, "Logindaten sind unvollstndig")
    End If
    Call API_ShutDown(c_Socket, SD_BOTH)
    Call API_CloseSocket(c_Socket)
    c_Socket = INVALID_SOCKET
End If

End Function

Private Sub Class_Initialize()
c_Socket = INVALID_SOCKET
Set SocketWindow = New clsSocketWindow
c_lngMSG_ID = RegisterWindowMessage("AVBM.Login")
SocketWindow.AddMSGFilter = c_lngMSG_ID
End Sub

Private Sub Class_Terminate()
On Error Resume Next
'Klassenreferenz lschen
Set objClassReferenz = Nothing
'Socket beenden
If c_Socket <> INVALID_SOCKET Then Call API_CloseSocket(c_Socket)
'Referenz auf das Fenster lschen
Call SocketWindow.DestroyAndUnhook
Set SocketWindow = Nothing

End Sub
Private Function GetSocketBufferSize() As Boolean
Dim c_RecvBuffer As Long
Dim c_SendBuffer As Long

Call API_GetSockOpt(c_Socket, SOL_SOCKET, SO_RCVBUF, c_RecvBuffer, 4&)
If c_RecvBuffer > 0 Then m_RecvBuffer = c_RecvBuffer
Call API_GetSockOpt(c_Socket, SOL_SOCKET, SO_SNDBUF, c_SendBuffer, 4&)
If c_SendBuffer > 0 Then m_SendBuffer = c_SendBuffer

End Function
Private Sub SocketWindow_SocketQuery(lngSocket As Long, lngEventID As Long, lngError As Long)
Dim strRecived As String, bytes As Long
Dim lngNetEvent As NetworkEventID
Dim udtSockAddr As SockAddr

lngSocket = 0

If lngError Then
    clsLogin_SocketsError = True
    Debug.Print "Socketerror Login: "; lngError
    c_LastWSAEventError = lngError
End If

lngNetEvent = lngEventID

Select Case lngNetEvent
    Case FD_CONNECT
        objClassReferenz.SocketLog "Login, FD_Connect Event", -1, SOCKETLOG_INFO
        API_GetSockName c_Socket, udtSockAddr, Len(udtSockAddr)
        LocalUser.cpLAN_IP = GetAscIP(udtSockAddr.sin_addr)
        If lngError = 0 Then
            Call GetSocketBufferSize
            clsLogin_Connected = True
        End If
    Case FD_READ
        objClassReferenz.SocketLog "Login, FD_Read Event", -1, SOCKETLOG_INFO
        strRecived = String$(MAX_RECIVEBUFFER, 0)
        bytes = API_Recive(c_Socket, ByVal strRecived, Len(strRecived), 0)
        If bytes > 0 Then
            strData = Left$(strRecived, bytes)
            bolDataRecived = True
        End If
    Case FD_Write
        objClassReferenz.SocketLog "Login, FD_Write Event", -1, SOCKETLOG_INFO
    Case FD_CLOSE
        objClassReferenz.SocketLog "Login, FD_Close Event", -1, SOCKETLOG_INFO
        'Call API_CloseSocket(c_Socket)
        'c_Socket = INVALID_SOCKET
    Case FD_OOB
        objClassReferenz.SocketLog "Login, FD_OOB Event", -1, SOCKETLOG_INFO
    Case SO_LINGER
        objClassReferenz.SocketLog "Login, SO_Linger Event", -1, SOCKETLOG_INFO
    Case SOL_SOCKET
        objClassReferenz.SocketLog "Login, SOL_Socket Event", -1, SOCKETLOG_INFO
End Select

strRecived = vbNullString

End Sub






