VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSocket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************************
'*      Die Socketklasse der Klassenkombination, sie wird von der WinSockKlasse
'*      instanziert.
'*      Diese Klasse darf nicht anders instanziert werden!!!!
'*      Der Klassenname darf nicht verndert werden!!!
'*
'*      Erstellt fr ActiveVB Instant Messenger
'*      (c) 2003 Kai Liebenau
'*      Version: V 0.8.8
'*
'*  History:
'*
'*  Ver 0.8.8   - In Work
'*              - Connect Errorhandling bei Aufruf API_Connect gendert
'*              - Errorhandling bei Resolve Hostname gendert
'*              - TimeOut bei Connect eingefhrt, falls alle anderen Timeouts versagen
'*  Ver 0.8.7   - c_SocketsError wurde zu frh zurckgesetzt, Sub DestroySocket angepasst
'*  Ver 0.8.6   - Nothing
'*  Ver 0.8.5   - FD_CLOSE handling gendert, es wurde zu frh die Klasse zurckgesetzt
'*  Ver 0.8.4   - clsSocket_SendData, erweitert um den Returnwert -1
'*              - Logging in Function SocketWndProc erweitert
'*  Ver 0.8.3   - Steuerung fr FT Buffersize implementiert
'*              - Neue Property: OwnedFTSize
'*              - Class_Terminate: RemoveFTSize
'*              - SendFile: Steuerung fr RemoveFTSize
'*              - Property FileSend: Steuerung fr AddFTSize
'*  Ver 0.8.2   - Fix beim Filesenden, die Bufferberechnung war falsch
'*  Ver 0.8.1   - Implementierung der Schnittstelle ISocket
'******************************************************************************

Option Explicit

'Private WithEvents SocketWindow As PictureBox 'Socketfensterobjekt
'Private fMainForm               As Form       'Referenzobjekt zur Form auf dem das Socketfenster liegt
Private objClassReferenz        As ISocket    'Referenzobjekt zur Managementklasse

Dim c_SendBuffer            As Long           'Gre des Sendebuffer
Dim c_RecvBuffer            As Long           'Gre des Empfangsbuffer
Dim c_lngIndex              As Long           'Index der Klasse
'Dim c_HWndtoMsg             As Long           'Fensterhandle zum Socketwindow
Dim c_Socket                As Long           'Sockethandle
Dim c_strRemoteIP           As String         'IP Addresse des RemoteHost
Dim c_bolSendComplete       As Boolean        'WriteEvent fired
Dim c_bolOwnedFTSize        As Boolean        'SendSocket, dann FTSize anpassen
Dim c_Connected             As Boolean        'ist Socket Connected
Dim c_Listener              As Boolean        'Listener aktiv
Dim c_SocketsError          As Boolean        'Socketerror aufgetreten
Dim c_SocketClosed          As Boolean        'Closeevent fired
Dim c_strFileName           As String         'Filename welches gesendet oder empfangen werden soll
Dim c_lngFileLength         As Long           'Filelnge
Dim c_bolFileRecive         As Boolean        'File empfangen
Dim c_bolFileTransferAbort  As Boolean        'Filetransfer abbrechen
Dim c_bolFileChunkNext      As Boolean        'z.Z. Obsolete
Dim c_strUsername           As String         'Username des File-Senders
Dim c_SocketAsyncState      As NetworkEventID
Dim c_bolBroadcast          As Boolean
Dim c_strBroadcastMSG       As String
Dim c_barrFileData()        As Byte
Property Get Connected() As Boolean
Connected = c_Connected
End Property
Public Sub clsSocket_SetReferenz(ByRef objClassRef As ISocket)
'Objekt Referenz setzen
Set objClassReferenz = objClassRef
End Sub

Public Function clsSocket_ListenPort(Optional Port As Long = SOCKET_DEFAULT_PORT) As Boolean
On Error GoTo Listen_Error
    Dim s As Long, dummy As Long
    Dim sockin As SockAddr
    
    'sockin = saZero     'zero out the structure
    sockin.sin_family = AF_INET
    sockin.sin_port = htons(Port)
    If sockin.sin_port = INVALID_PORT Then
        clsSocket_ListenPort = False
        Call objClassReferenz.SocketLog("Faild to Convert Port", c_lngIndex, SOCKETLOG_ERROR_EX)
        Exit Function
    End If
    sockin.sin_addr = htonl(INADDR_ANY)
    If c_Socket = INVALID_SOCKET Then
        'Call CreateSocketWindow
        
        c_Socket = socket(AF_INET, SOCK_STREAM, 0)
        Call objClassReferenz.AddToWindow(Me, c_Socket)
        If c_Socket = INVALID_SOCKET Then
            Call objClassReferenz.SocketLog("Create Socket faild: " & GetWSAErrorString(WSAGetLastError), c_lngIndex, SOCKETLOG_ERROR_EX)
            clsSocket_ListenPort = False
            Exit Function
        End If
        If API_Bind(c_Socket, sockin, Len(sockin)) Then
            Call objClassReferenz.SocketLog("Faild Socket Bind", c_lngIndex, SOCKETLOG_ERROR_EX)
            GoTo Listen_Error
            Exit Function
        End If
    End If
    c_SocketAsyncState = FD_ACCEPT
    If WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState) Then
        Call objClassReferenz.SocketLog("Faild to Set Socket to NonBlocking", c_lngIndex, SOCKETLOG_ERROR_EX)
        GoTo Listen_Error
        Exit Function
    End If

    If API_listen(c_Socket, 2) Then
        Call objClassReferenz.SocketLog("Faild to Listen", c_lngIndex, SOCKETLOG_ERROR_EX)
        GoTo Listen_Error
        Exit Function
    End If
    
Call GetSocketBufferSize

clsSocket_ListenPort = True

c_Listener = True
Exit Function
Listen_Error:
Call objClassReferenz.SocketLog("APIerror: " & GetWSAErrorString(Err.LastDllError), c_lngIndex, SOCKETLOG_ERROR_EX)
Call objClassReferenz.SocketLog("Socketerror: " & GetWSAErrorString(WSAGetLastError), c_lngIndex, SOCKETLOG_ERROR_EX)
If c_Socket > 0 Then DestroySocket

clsSocket_ListenPort = False
End Function
Public Function clsSocket_Connect(ByVal strDest As String) As Boolean
On Error Resume Next
Dim tTime As Date
Dim lngTimeOut As Long
Dim lngIP As Long
Dim SocketBuffer As SockAddr
Dim rc As Long
Dim strHost As String
Dim lngPort As Long
Dim lWSAError As Long

If c_Socket <> INVALID_SOCKET Then
    clsSocket_Connect = True
    Exit Function
End If

'Connection herstellen
c_Socket = socket(AF_INET, SOCK_STREAM, 0)
'konnte die Socket erstellt werden
If c_Socket = INVALID_SOCKET Then
    Call objClassReferenz.SocketLog("Connect Faild Create Socket" & GetWSAErrorString(WSAGetLastError), c_lngIndex, SOCKETLOG_ERROR_EX)
    Exit Function
End If
objClassReferenz.SocketLog "Create New SocketHandle: " & c_Socket, c_lngIndex, SOCKETLOG_INFO
'If m_ProxyEnabled = True Then
'    strHost = m_ProxyServer
'    lngPort = m_ProxyPort
'Else
    strHost = strDest
    lngPort = m_SOCKET_DEFAULT_PORT
'End If
lngIP = GetHostByNameAlias(strHost, lWSAError)
If lngIP = -1 Then 'IP konnte nicht ermittelt werden
    Call objClassReferenz.SocketLog("Cant Resolve Hostname, " & GetWSAErrorString(lWSAError), c_lngIndex, SOCKETLOG_WARNING_EX)
    Call DestroySocket
    c_Socket = INVALID_SOCKET
    Exit Function
End If

SocketBuffer.sin_family = AF_INET
SocketBuffer.sin_port = htons(lngPort)
SocketBuffer.sin_addr = lngIP
SocketBuffer.sin_zero = String$(8, 0)

'If c_HWndtoMsg <> 0 Then c_HWndtoMsg = 0: Debug.Print "Fensterhandle existiert schon!!"

Call objClassReferenz.AddToWindow(Me, c_Socket)

'Socketmode auf Non-Blocking stellen
c_SocketAsyncState = FD_CONNECT
If WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState) <> SOCKET_ERROR Then
    'Host connecten
    If API_Connect(c_Socket, SocketBuffer, Len(SocketBuffer)) = SOCKET_ERROR Then
        If Err.LastDllError <> WSAEWOULDBLOCK Then 'ConnectError ?
            objClassReferenz.SocketLog "Socket Connect, " & GetWSAErrorString(Err.LastDllError), -1, SOCKETLOG_ERROR_EX
            Call API_CloseSocket(c_Socket)
            c_Socket = INVALID_SOCKET
            Exit Function
        Else
            objClassReferenz.SocketLog "Will Connecting to: " & strHost, c_lngIndex, SOCKETLOG_INFO
        End If
    End If
Else
    Call objClassReferenz.SocketLog("Faild to Set NonBlockingMode " & GetWSAErrorString(WSAGetLastError), c_lngIndex, SOCKETLOG_ERROR_EX)
    Call DestroySocket
    c_Socket = INVALID_SOCKET
    Exit Function
End If
'warten das die Connection zum Host aufgebaut ist, nicht bei Broadcastmessages
tTime = Now
If Not c_bolBroadcast Then
    Do While c_Connected = False And c_SocketsError = False
        DoEvents
        Sleep 1
        If DateDiff("s", tTime, Now) > TIMEOUT_CONNECT Then c_SocketsError = True: Exit Do
    Loop
End If
'Wenn beim connecten ein Fehler aufgetreten ist
If c_SocketsError = True Then
    Call objClassReferenz.SocketLog("Connection faild", c_lngIndex, SOCKETLOG_WARNING_EX)
    Call DestroySocket
    Exit Function
End If

clsSocket_Connect = True

End Function

Public Function clsSocket_SendData(ByRef strData As String, ByVal strDest As String, Optional bolBroadcast As Boolean = False) As Long
On Error Resume Next
Dim tTime As Date

'Raus, wenn die Socket einen Fehler hat
If c_SocketsError = True Then clsSocket_SendData = -10: Exit Function

If bolBroadcast = True And c_Connected = False Then
    c_bolBroadcast = bolBroadcast
    c_strBroadcastMSG = strData
End If

c_strRemoteIP = strDest

'Besteht schon eine Verbindung?
If c_Socket = INVALID_SOCKET And c_SocketsError = False Then
    If clsSocket_Connect(strDest) = False Then
        clsSocket_SendData = -2
        Exit Function
    End If
End If

'Soll es eine Broadcastmessage werden?
If c_bolBroadcast = True And bolBroadcast = True Then
    clsSocket_SendData = Len(strData)
    objClassReferenz.SocketLog "Sending BroadcastMessage, Len = " & Len(strData), c_lngIndex, SOCKETLOG_INFO
    Exit Function
End If

'gibt es ein Socket
If c_Socket Then
    c_SocketAsyncState = FD_CLOSE Or FD_READ Or FD_Write
    If WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState) = SOCKET_ERROR Then
        Call objClassReferenz.SocketLog("Faild to Set NonBlockingMode " & GetWSAErrorString(WSAGetLastError), c_lngIndex, SOCKETLOG_ERROR_EX)
        Call DestroySocket
        c_Socket = INVALID_SOCKET
        clsSocket_SendData = -10
        Exit Function
    End If
    'Wenn ja, dann nix wie wech mit den Daten
    objClassReferenz.SocketLog "clsSocket_SendData PacketSize: " & Len(strData), c_lngIndex, SOCKETLOG_INFO_EX
    'c_bolSendComplete = False
    clsSocket_SendData = API_SocketSend(c_Socket, ByVal strData, Len(strData), 0)
End If
If c_SocketsError = True Then clsSocket_SendData = -10
End Function
Private Sub CreateSocketWindow()

End Sub
Public Sub DestroySocket()
On Error Resume Next

'Variablen setzen auf Abbruch aller Events
c_bolFileTransferAbort = True
c_bolFileRecive = False
c_SocketClosed = True
c_Connected = False
c_bolBroadcast = False
'c_SocketsError = False
c_strBroadcastMSG = vbNullString
c_strRemoteIP = vbNullString
c_strUsername = vbNullString
c_lngIndex = -2
'Socket beenden
If c_Socket <> INVALID_SOCKET Then
    Debug.Print "Socket Shutdown"
    Call objClassReferenz.DelFromWindow(c_Socket)
    Call API_ShutDown(c_Socket, SD_BOTH)
    Call API_CloseSocket(c_Socket)
    c_Socket = INVALID_SOCKET

End If
'Debug.Print "SocketWindow removed"
End Sub
Property Get ClassIndex() As Long
'Klassenindex zurckgeben
    ClassIndex = c_lngIndex
End Property
Property Let ClassIndex(newIndex As Long)
'Klassenindex einstellen
    c_lngIndex = newIndex
End Property

Private Sub Class_Initialize()
On Error Resume Next

c_Socket = INVALID_SOCKET
c_strBroadcastMSG = vbNullString
c_strRemoteIP = vbNullString
c_strUsername = vbNullString
c_lngIndex = -2
End Sub

Private Sub Class_Terminate()
On Error Resume Next

DestroySocket
If c_bolOwnedFTSize Then objClassReferenz.RemoveFileTransferSend
c_bolOwnedFTSize = False
'Klassenreferenz lschen
Set objClassReferenz = Nothing
'Set fMainForm = Nothing

End Sub
Private Function GetSocketBufferSize() As Boolean

Call API_GetSockOpt(c_Socket, SOL_SOCKET, SO_RCVBUF, c_RecvBuffer, 4&)
If c_RecvBuffer > 0 Then m_RecvBuffer = c_RecvBuffer
Call API_GetSockOpt(c_Socket, SOL_SOCKET, SO_SNDBUF, c_SendBuffer, 4&)
If c_SendBuffer > 0 Then m_SendBuffer = c_SendBuffer

End Function


Property Get ConnectionClosed() As Boolean
    ConnectionClosed = c_SocketClosed
End Property
Property Get FileName() As String
    FileName = c_strFileName
End Property
Property Let FileName(strFilename As String)
    c_strFileName = strFilename
End Property
Property Get FileLength() As Long
    FileLength = FileLen(c_strFileName)
End Property
Property Let FileLength(lngLength As Long)
    c_lngFileLength = lngLength
End Property
Property Let FileTransferNext(bolNewValue As Boolean)
    c_bolFileChunkNext = bolNewValue
End Property
Property Let FileTransferAbort(bolNewValue As Boolean)
    c_bolFileTransferAbort = bolNewValue
End Property
Property Let OwnedFTSize(bolNewValue As Boolean)
c_bolOwnedFTSize = bolNewValue
End Property

Property Let UserName(strNewValue As String)
    c_strUsername = strNewValue
End Property
Property Get FileSend() As Boolean
On Error Resume Next
Dim lngLength           As Long
Dim lngPosition         As Long
Dim lngBytesSend        As Long
Dim intFile             As Integer
Dim lngCounter          As Long
Dim bolExit             As Boolean
Dim tTime               As Date

Erase c_barrFileData
'File verschlsselt holen
CryptoInstance.GetCryptedFile c_strFileName, c_strRemoteIP, c_strUsername, c_barrFileData

lngLength = UBound(c_barrFileData)
If lngLength = 0 Then
    'Keine Filedaten im Bytearray
    objClassReferenz.SocketLog "Error: Keine Filedaten von der Cryptoinstanze erhalten!", c_lngIndex, SOCKETLOG_ERROR_EX
    Exit Property
End If

c_bolFileTransferAbort = False
lngLength = c_SendBuffer - 100
If lngLength > c_lngFileLength Then lngLength = c_lngFileLength

Sleep 200
DoEvents
Sleep 200
DoEvents

c_SocketAsyncState = FD_CLOSE Or FD_Write
Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState)
FileSend = True
If Not c_bolOwnedFTSize Then objClassReferenz.AddFileTransferSend
c_bolOwnedFTSize = True
End Property
Public Static Function SendFile() As Long
On Error Resume Next
Dim lngLength           As Long
Static lngPosition         As Long
Dim lngBytesSend        As Long
Dim lngBufferSize       As Long
Dim intFile             As Integer
Dim lngCounter          As Long
Dim bolExit             As Boolean
Dim bolTimeout          As Boolean
Dim tTime               As Date

If lngCounter < m_FTSendMultipiller Then
    lngCounter = lngCounter + 1
    SendFile = 1
    Exit Function
End If
lngCounter = 1
'Buffersizeberechnung
lngLength = c_lngFileLength - lngPosition
If lngLength > m_FTSendBuffer Then lngLength = m_FTSendBuffer

If CLng(tTime) = 0 Then tTime = Now
'If lngLength = 0 Then lngLength = lngBufferSize '- 100

c_bolSendComplete = False
If c_Socket <> INVALID_SOCKET Then
    lngBytesSend = API_SocketSend(c_Socket, c_barrFileData(lngPosition), lngLength, 0)
Else
    c_SocketsError = True
End If
'DoEvents

If lngBytesSend < 1 Then
    lngBytesSend = 0
    If CLng(DateDiff("s", tTime, Now)) > TIMEOUT_FILETRANSFER Then bolTimeout = True
Else
    tTime = Now
End If

'Abbrucherkennung
bolExit = c_bolFileTransferAbort Or c_SocketsError Or c_SocketClosed Or bolTimeout

lngPosition = lngPosition + lngBytesSend
Debug.Print lngPosition
If lngBytesSend Then objClassReferenz.FiletransferProgress c_lngIndex, lngPosition, True
'Bytes die gesendet werden einstellen
If lngLength > c_lngFileLength - lngPosition Then lngLength = c_lngFileLength - lngPosition

If c_lngFileLength = lngPosition Then 'Exit
    'Fertig
    Debug.Print "Bytes sends: "; lngPosition
    Erase c_barrFileData
    SendFile = 0
    If c_bolOwnedFTSize Then objClassReferenz.RemoveFileTransferSend
    c_bolOwnedFTSize = False
Else
    If bolExit Then
        'Not Resume
        If bolTimeout Then
            SendFile = -2
        Else
            SendFile = -1
        End If
        Erase c_barrFileData
        If c_bolOwnedFTSize Then objClassReferenz.RemoveFileTransferSend
        c_bolOwnedFTSize = False
    Else
        'Resume
        SendFile = 1
    End If
End If

End Function
Property Let FileRecive(bolNewValue As Boolean)
Dim strFilePath         As String

c_SocketAsyncState = FD_CLOSE 'Or FD_READ Or FD_Write
Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState)

strFilePath = Left$(c_strFileName, InStrRev(c_strFileName, "\"))
If Right$(strFilePath, 1) = "\" Then strFilePath = Left$(strFilePath, Len(strFilePath) - 1)
'c_strFileName = Mid$(c_strFileName, InStrRev(c_strFileName, "\") + 1)

Call MakeSureDirectoryPathExists(strFilePath)

m_IncomingFilePath = vbNullString
ReDim c_barrFileData(0 To c_lngFileLength - 1)

'DoEvents
End Property
Public Static Function ReciveFile() As Long
On Error Resume Next
Dim tTime               As Date
Dim lngBytesRecive      As Long
Dim lngBufferSize       As Long
Dim intFile             As Integer
Dim lngPosition         As Long
Dim bolExit             As Boolean
Dim bolTimeout          As Boolean

lngBufferSize = c_RecvBuffer
If lngBufferSize > c_lngFileLength - lngPosition Then
    lngBufferSize = c_lngFileLength - lngPosition
End If

If CLng(tTime) = 0 Then tTime = Now

If c_Socket <> INVALID_SOCKET Then _
    lngBytesRecive = API_Recive(c_Socket, c_barrFileData(lngPosition), lngBufferSize, 0)
    
    If lngBytesRecive < 1 Then
        If CLng(DateDiff("s", tTime, Now)) > TIMEOUT_FILETRANSFER Then bolTimeout = True
    Else
        lngPosition = lngPosition + lngBytesRecive
        objClassReferenz.FiletransferProgress c_lngIndex, lngPosition, False
        tTime = Now
    End If

bolExit = c_bolFileTransferAbort Or c_SocketsError Or c_SocketClosed Or bolTimeout

If bolExit Then
    Erase c_barrFileData
    If Not c_bolFileTransferAbort Then
        ReciveFile = -2 'Faild
    Else
        ReciveFile = -1 'Abort
    End If
    Exit Function
End If

ReciveFile = 1
If c_lngFileLength = lngPosition Then
    'File zur entschlsselung bergeben
    CryptoInstance.SaveCryptedFile c_strFileName, c_strRemoteIP, c_strUsername, c_barrFileData
    ReciveFile = 0
    Erase c_barrFileData
    c_SocketAsyncState = FD_CLOSE Or FD_READ Or FD_Write
    Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState)
End If
End Function


Property Get SendBufferLength() As Long
 SendBufferLength = c_SendBuffer
End Property



'Private Sub SocketWindow_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Sub SocketWndProc(ByVal lngNetEvent As Long, lngError As Long)
'Dim ReadSocket As Long, SocketAddr As SockAddr, lngSocketLength As Long
Dim strRecived As String, bytes As Long
'Dim lngNetEvent As NetworkEventID
'Dim lngError As Long
Debug.Print "NetID: "; GetFDString(lngNetEvent); " Error: "; lngError
On Error Resume Next
'Debug.Print Shift & vbTab & "&H" & Hex(Shift)
'Socketfehler ermitteln
'lngError = fMainForm.ScaleY(Y, fMainForm.ScaleMode, vbPixels)
If lngError Then
    c_SocketsError = True
    Call objClassReferenz.SocketLog("SocketEvent: " & GetFDString(lngNetEvent) & ", Socketwindowerror: " & GetWSAErrorString(lngError), c_lngIndex, SOCKETLOG_ERROR_EX)
    Call objClassReferenz.ConnectionHasLost(c_lngIndex)
    c_SocketClosed = True
    Call DestroySocket
    Exit Sub
End If

'Socketevent ermitteln
'lngNetEvent = fMainForm.ScaleX(X, SocketWindow.ScaleMode, vbPixels)

Select Case lngNetEvent
    Case FD_CONNECT
        Call objClassReferenz.SocketLog("FD_Connect_Event", c_lngIndex, SOCKETLOG_INFO)
        Call GetSocketBufferSize
        If lngError = 0 Then c_Connected = True
        If c_bolBroadcast Then
            Call API_SocketSend(c_Socket, ByVal c_strBroadcastMSG, Len(c_strBroadcastMSG), 0)
            c_SocketAsyncState = FD_CLOSE Or FD_READ Or FD_Write
            Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState)
            'Variablen zurcksetzen
            c_bolBroadcast = False
            c_strBroadcastMSG = vbNullString
        End If
    Case FD_ACCEPT
        Call objClassReferenz.SocketLog("FD_Accept Event", c_lngIndex, SOCKETLOG_INFO)
        c_SocketAsyncState = 0
        Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, 0, c_SocketAsyncState)
        'Neu:
        If objClassReferenz.AcceptRequest(c_Socket) = 0 Then
            'alle Sockets belegt
            Call RejectAcceptRequest
        End If
        Call clsSocket_ListenPort
    Case FD_READ
        Call objClassReferenz.SocketLog("FD_Read Event", c_lngIndex, SOCKETLOG_INFO)
        strRecived = String$(c_RecvBuffer, 0)
        bytes = API_Recive(c_Socket, ByVal strRecived, Len(strRecived), 0)
        If bytes > 0 Then
            strRecived = Left$(strRecived, bytes)
            objClassReferenz.IncomingData strRecived, c_strRemoteIP, c_lngIndex
        End If
    Case FD_Write
        Call objClassReferenz.SocketLog("FD_Write Event", c_lngIndex, SOCKETLOG_INFO)
        c_bolSendComplete = True
        'DoEvents
    Case FD_CLOSE
        Call objClassReferenz.SocketLog("FD_Close Event", c_lngIndex, SOCKETLOG_INFO_EX)
        objClassReferenz.ConnectionHasLost c_lngIndex
        Call DestroySocket
        'c_Socket = INVALID_SOCKET
    Case FD_OOB
        Call objClassReferenz.SocketLog("FD_OOB Event", c_lngIndex, SOCKETLOG_INFO)
        
    Case SO_LINGER
        Call objClassReferenz.SocketLog("SO_Linger Event", c_lngIndex, SOCKETLOG_INFO)
        
    Case SOL_SOCKET
        Call objClassReferenz.SocketLog("SOL_Socket Event", c_lngIndex, SOCKETLOG_INFO)
        
End Select

strRecived = vbNullString
End Sub
Public Function AcceptSocket(ByVal SocketID As Long) As Long
Dim SocketAddr As SockAddr, lngSocketLength As Long
Debug.Print "Entry AcceptSocket"
lngSocketLength = Len(SocketAddr)
'Verbindung annehmen
c_Socket = WSAAccept(SocketID, SocketAddr, lngSocketLength, 0, 0)
If c_Socket = INVALID_SOCKET Then Debug.Print "Error Accept "; SocketID; " "; c_Socket
'Fenster erstellen
'Call CreateSocketWindow
Call objClassReferenz.AddToWindow(Me, c_Socket)

c_SocketAsyncState = FD_CLOSE Or FD_READ Or FD_Write
Debug.Print "SocketWindowHandle: "; m_lngSocketWindowhWnd
Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState)

Debug.Print "Socket Added: "; c_Socket
c_strRemoteIP = GetAscIP(SocketAddr.sin_addr)
Call objClassReferenz.SocketLog("Accept from: " & c_strRemoteIP, c_lngIndex, SOCKETLOG_INFO_EX)

Call GetSocketBufferSize
objClassReferenz.SetDestination c_lngIndex, c_strRemoteIP
c_Connected = True
End Function

Private Function RejectAcceptRequest() As Long
Dim lngReadSocket   As Long
Dim cHTTP           As clsWinSockHTTP
Dim SocketAddr      As SockAddr
Dim lngSocketLength As Long
Dim strMSG          As String

Set cHTTP = New clsWinSockHTTP

cHTTP.Answer = True
cHTTP.Connection = "close"
cHTTP.SocketCommand = SOCKET_MAX_CONNECTION
strMSG = cHTTP.GetHTTP_Packet
Set cHTTP = Nothing
'Request annehmen
lngSocketLength = Len(SocketAddr)
lngReadSocket = WSAAccept(c_Socket, SocketAddr, lngSocketLength, 0, 0)
'bescheid sagen das wir keine freie Socket mehr haben
Call API_SocketSend(lngReadSocket, ByVal strMSG, Len(strMSG), 0)
'warten, bis die Nachricht da ist und die Socket beendet wurde
DoEvents
Call Sleep(200)
'DoEvents
Call Sleep(200)
'DoEvents
Call Sleep(200)
'Eigene Socket schlieen
Call API_CloseSocket(lngReadSocket)
Call API_ShutDown(lngReadSocket, 0)

End Function
Public Sub SetAsyncState()
If c_Socket <> INVALID_SOCKET And m_lngSocketWindowhWnd <> 0 Then
    'Call WSAAsyncSelect(c_Socket, 0, 0, 0)
    'c_SocketAsyncState = FD_CLOSE Or FD_READ Or FD_Write
    Call WSAAsyncSelect(c_Socket, m_lngSocketWindowhWnd, m_lngSocketMSG, c_SocketAsyncState)
End If
End Sub

Private Function GetFDString(ByVal NetID As Long) As String
Select Case NetID
    Case FD_ACCEPT: GetFDString = "FD_ACCEPT"
    Case FD_CLOSE: GetFDString = "FD_CLOSE"
    Case FD_CONNECT: GetFDString = "FD_CONNECT"
    Case FD_OOB: GetFDString = "FD_OOB"
    Case FD_READ: GetFDString = "FD_READ"
    Case FD_Write: GetFDString = "FD_Write"
    Case Else: GetFDString = "&H" & Hex$(NetID)
End Select
End Function
