VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWinSockHTTP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************************
'*      Die WinSockHTTPKlasse der Klassenkombination
'*
'*      Erstellt fr ActiveVB Instant Messenger
'*      (c) 2003 Kai Liebenau
'*      Version: V 0.8.8
'*
'*  History:
'*  Ver 0.8.8   - Einbau von IsBufferCalculate
'*              - Einbau von GetPacketForBuffer
'*              - diverse Bugfixings
'*  Ver 0.8.7   - Nothing
'*  Ver 0.8.6   - Nothing
'*  Ver 0.8.5   - Nothing
'*  Ver 0.8.4   - nderungen wegen der Protokollversion
'*  Ver 0.8.3   - Nothing
'*  Ver 0.8.2   - Nothing
'*  Ver 0.8.1   - Umbenennung der Function GetHTTPHeader in GetHTTP_Packet
'******************************************************************************

Option Explicit

Dim c_Connection            As String
Dim c_User                  As String
Dim c_IP                    As String
Dim c_MyIP                  As String
Dim c_Content_Type          As String
Dim c_Content_Length        As Long
Dim c_Set_Content_Length    As Long
Dim c_Content_Range         As Long
Dim c_FileLength            As Long
Dim c_Proxy_Connection      As String
Dim c_ProtokollVersion      As Long
Dim c_Answer                As Boolean
Dim c_HTTPGet               As Boolean
Dim c_FileName              As String
Dim c_SocketCommand         As String
Dim c_SocketCommand_Routing As String
Dim c_SocketConnQuality     As Long
Dim c_Socket_ForwardTo      As String
Dim c_Socket_ForwardToUser  As String
Dim c_str_Message           As String
Dim c_str_Via               As String
Dim c_OverProxy             As Boolean
Dim c_MessageWaiting        As Boolean
Dim c_IsBufferCalc          As Boolean
Dim c_IP_Packet             As String
Dim c_ThisPacket            As String
Dim c_PacketSize            As Long
Dim c_HeaderLength          As Long
Dim c_ErrorDescription      As String
Dim c_ErrorCode             As String
'***********************************************************************************************************
'* HTTP Headervariablen
'***********************************************************************************************************
Property Get GetPacketForBuffer() As String
    GetPacketForBuffer = c_ThisPacket
End Property
Property Get IsBufferCalculate() As Boolean
    IsBufferCalculate = c_IsBufferCalc
End Property
Property Get ErrorCode() As String
    ErrorCode = c_ErrorCode
End Property
Property Get ErrorDescription() As String
    ErrorDescription = c_ErrorDescription
End Property
Property Get Connection() As String
    Connection = c_Connection
End Property
Property Let Connection(ByVal NewValue As String)
    c_Connection = NewValue
End Property
Property Get IP() As String
    IP = c_IP
End Property
Property Let IP(ByVal NewValue As String)
    c_IP = NewValue
End Property
Property Get SourceIP() As String
    SourceIP = c_MyIP
End Property
Property Get Content_Type() As String
    Content_Type = c_Content_Type
End Property
Property Let Content_Type(ByVal NewValue As String)
    c_Content_Type = NewValue
End Property
Property Get Content_Length() As Long
    Content_Length = c_Content_Length
End Property
Property Let Content_Length(ByVal NewValue As Long)
    c_Content_Length = NewValue
End Property
Property Let Set_Content_Length(ByVal NewValue As Long)
    c_Set_Content_Length = NewValue
End Property
Property Get Content_Range() As Long
    Content_Range = c_Content_Range
End Property
Property Let Content_Range(ByVal NewValue As Long)
    c_Content_Range = NewValue
End Property
Property Get ProxyConnection() As String
    ProxyConnection = c_Proxy_Connection
End Property
Property Let ProxyConnection(ByVal NewValue As String)
    c_Proxy_Connection = NewValue
End Property
'****************************************************************************************************************
'* My Header, diese Variablen gehren zum Content!!!!!!!!!
'****************************************************************************************************************
Property Get FileLength() As Long
    FileLength = c_FileLength
End Property
Property Let FileLength(ByVal NewValue As Long)
    c_FileLength = NewValue
    'Call SetContentLength
End Property
Property Get FileName() As String
    FileName = c_FileName
End Property
Property Let FileName(ByVal NewValue As String)
    c_FileName = NewValue
    'Call SetContentLength
End Property
Property Get SocketConnectionQuality() As Long
    SocketConnectionQuality = c_SocketConnQuality
End Property
Property Let SocketConnectionQuality(ByVal NewValue As Long)
    c_SocketConnQuality = NewValue
    'Call SetContentLength
End Property
Property Get SocketCommand() As String
    SocketCommand = c_SocketCommand
End Property
Property Let SocketCommand(ByVal NewValue As String)
    c_SocketCommand = NewValue
    'Call SetContentLength
End Property
Property Get SocketCommandRouting() As String
    SocketCommandRouting = c_SocketCommand_Routing
End Property
Property Let SocketCommandRouting(ByVal NewValue As String)
    c_SocketCommand_Routing = NewValue
    'Call SetContentLength
End Property
Property Get SocketForwardTo() As String
    SocketForwardTo = c_Socket_ForwardTo
End Property
Property Let SocketForwardTo(ByVal NewValue As String)
    c_Socket_ForwardTo = NewValue
    'Call SetContentLength
End Property
Property Get SocketForwardToUser() As String
    SocketForwardToUser = c_Socket_ForwardToUser
End Property
Property Let SocketForwardToUser(ByVal NewValue As String)
    c_Socket_ForwardToUser = NewValue
    'Call SetContentLength
End Property

Property Get RequestMessage() As String
    RequestMessage = c_str_Message
End Property
Property Let RequestMessage(ByVal NewValue As String)
    c_str_Message = NewValue
    'Call SetContentLength
End Property
Property Get ClientProtokollVersion() As Long
    ClientProtokollVersion = c_ProtokollVersion
End Property
Property Let ClientProtokollVersion(ByVal NewValue As Long)
    c_ProtokollVersion = NewValue
    'Call SetContentLength
End Property
Property Get User() As String
    User = c_User
End Property
Property Let User(ByVal NewValue As String)
    c_User = NewValue
    'Call SetContentLength
End Property
'*************************************************************************************************************
'* Zusatzvariablen die nicht im Packet sind
'*************************************************************************************************************
Property Get OverProxy() As Boolean
    OverProxy = c_OverProxy
End Property
Property Let OverProxy(ByVal NewValue As Boolean)
    c_OverProxy = NewValue
End Property
Property Get Answer() As Boolean
    Answer = c_Answer
End Property
Property Let Answer(ByVal NewValue As Boolean)
    c_Answer = NewValue
End Property
Property Get MessageLength() As Long
    MessageLength = Len(c_str_Message)
End Property
Property Get MessageWaiting() As Boolean
    MessageWaiting = c_MessageWaiting
End Property
Property Get PacketSize() As Long
    PacketSize = c_PacketSize
End Property

Property Get HeaderLength() As Long
    HeaderLength = c_HeaderLength
End Property



Private Function GetHeaderItem(strItem As String, Optional Delimiter As String = vbCrLf) As String
Dim lngStart As Long
Dim lngEnd As Long
'Dim lngLength As Long

lngStart = InStrB(1, c_IP_Packet, strItem, vbTextCompare)
If lngStart Then
    lngStart = lngStart + LenB(strItem)
    lngEnd = InStrB(lngStart, c_IP_Packet, Delimiter, vbTextCompare)
    GetHeaderItem = MidB$(c_IP_Packet, lngStart, lngEnd - lngStart)
End If
End Function

Public Sub SetHTTPRequest(HTTPHeader As String)

c_IP_Packet = HTTPHeader

Call GetNextHTTPRequest

End Sub

Public Sub GetNextHTTPRequest()
Dim lStart            As Long
Dim lPosition         As Long
Dim lHTTPHeaderLen As Long

On Local Error Resume Next

c_MessageWaiting = False

lStart = InStr(1, c_IP_Packet, "HTTP/1.", vbTextCompare)
If lStart = 1 Then 'Answer
    'HTTP/1.0 200 OK
    c_ErrorCode = Mid$(c_IP_Packet, lStart + 9, 3)
    lPosition = InStr(1, c_IP_Packet, vbCrLf, vbTextCompare)
    c_ErrorDescription = Mid$(c_IP_Packet, lStart + 13, lPosition)
End If

'HTTP Header
c_MyIP = GetHeaderItem("MyIP: ")
c_Connection = GetHeaderItem("Connection: ")
c_Content_Type = GetHeaderItem("Content-Type: ")
c_Content_Length = CLng(Val(GetHeaderItem("Content-Length: ")))
c_Content_Range = CLng(Val(GetHeaderItem("Content-Range: ")))

c_str_Via = GetHeaderItem("Via: ")
If Len(c_str_Via) Then
    c_OverProxy = True
End If
'Headerlnge festhalten
lHTTPHeaderLen = InStr(1, c_IP_Packet, vbCrLf & vbCrLf, vbBinaryCompare) '+ 3
c_HeaderLength = lHTTPHeaderLen
lHTTPHeaderLen = lHTTPHeaderLen + 3
'Content
c_FileLength = CLng(Val(GetHeaderItem("FileLength: ")))
c_FileName = GetHeaderItem("FileName: ")
c_User = GetHeaderItem("Username: ")
c_SocketConnQuality = Val(GetHeaderItem("ConnectionQuality: "))
c_SocketCommand = GetHeaderItem("SocketCommand: ")
c_SocketCommand_Routing = GetHeaderItem("SocketCommandRouting: ")
c_Socket_ForwardTo = GetHeaderItem("SocketForwardTo: ")
c_Socket_ForwardToUser = GetHeaderItem("SocketForwardToUser: ")
c_ProtokollVersion = Val(GetHeaderItem("ProtokollVersion: "))


lStart = InStr(1, c_IP_Packet, "DataAVBM: " & vbCrLf, vbTextCompare)
If lStart Then
    lStart = lStart + Len("DataAVBM: " & vbCrLf)
    c_str_Message = Mid$(c_IP_Packet, lStart, c_Content_Length - (lStart - lHTTPHeaderLen) + 1)
End If
'Headerlnge ermitteln
If c_HeaderLength > 0 Then c_HeaderLength = lHTTPHeaderLen
'If c_ProtokollVersion = 0 And c_Content_Type = "" Then c_IP_Packet = vbNullString
lStart = Len(c_IP_Packet)
If lStart Then c_MessageWaiting = True

If c_Content_Length > 0 And lHTTPHeaderLen > 3 Then
    c_ThisPacket = Mid$(c_IP_Packet, 1, c_Content_Length + lHTTPHeaderLen)
    c_IsBufferCalc = True
    c_IP_Packet = Mid$(c_IP_Packet, c_Content_Length + lHTTPHeaderLen + 1)
Else
    c_ThisPacket = c_IP_Packet
    c_IsBufferCalc = False
    c_IP_Packet = vbNullString
End If
c_PacketSize = Len(c_ThisPacket) 'lStart - Len(c_IP_Packet)
 

End Sub

Public Function GetHTTP_Packet() As String
Dim strContent As String
Dim dblNow As Double

dblNow = Now

If c_Answer Then
    GetHTTP_Packet = "HTTP/1.0 200 OK" & vbCrLf & _
                    "Server: AVBM 1.0" & vbCrLf
ElseIf c_HTTPGet Then
    GetHTTP_Packet = "GET " & "/cgi-bin/AVBMMessenger.php?" & dblNow & " HTTP/1.0" & vbCrLf & _
                    "Host: " & c_IP & ":" & m_SOCKET_DEFAULT_PORT & vbCrLf
Else
    GetHTTP_Packet = "POST " & "/cgi-bin/AVBMMessenger.php?" & dblNow & " HTTP/1.0" & vbCrLf & _
                    "Host: " & c_IP & ":" & m_SOCKET_DEFAULT_PORT & vbCrLf
End If
'Content definieren
strContent = "Username: " & c_User & vbCrLf & _
             "ProtokollVersion: " & c_ProtokollVersion & vbCrLf & _
             "SocketCommand: " & c_SocketCommand & vbCrLf
If c_SocketConnQuality Then strContent = strContent & "ConnectionQuality: " & CStr(c_SocketConnQuality) & vbCrLf
If Len(c_SocketCommand_Routing) Then strContent = strContent & "SocketCommandRouting: " & c_SocketCommand_Routing & vbCrLf
If Len(c_Socket_ForwardTo) Then strContent = strContent & "SocketForwardTo: " & c_Socket_ForwardTo & vbCrLf
If Len(c_Socket_ForwardToUser) Then strContent = strContent & "SocketForwardToUser: " & c_Socket_ForwardToUser & vbCrLf
If Len(c_FileName) Then strContent = strContent & "FileName: " & c_FileName & vbCrLf
If c_OverProxy Then strContent = strContent & "MyIP: " & c_MyIP & vbCrLf
If c_FileLength Then strContent = strContent & "FileLength: " & c_FileLength & vbCrLf
If Len(c_str_Message) Then
    strContent = strContent & "DataAVBM: " & vbCrLf & c_str_Message
    c_Content_Length = Len(strContent)
ElseIf c_Set_Content_Length Then
    strContent = strContent & "DataAVBM: " & vbCrLf
    c_Content_Length = Len(strContent) + c_Set_Content_Length
Else
    c_Content_Length = Len(strContent)
End If

GetHTTP_Packet = GetHTTP_Packet & "User-Agent: AVBM/1.0" & vbCrLf & _
        "Accept: */*" & vbCrLf & _
        "Connection: " & c_Connection & vbCrLf & _
        "Content-Length: " & c_Content_Length & vbCrLf & _
        "Content-Type: " & c_Content_Type & vbCrLf '& _
        "Content-Range: " & c_Content_Range & vbCrLf
'wenn es eine Proxyconnection ist
If c_OverProxy Then
    GetHTTP_Packet = GetHTTP_Packet & _
    "Proxy-Connection: " & c_Connection & vbCrLf & _
    "Pragma: no-cache" & vbCrLf
    
End If
GetHTTP_Packet = GetHTTP_Packet & vbCrLf & strContent
'GET /cbi-bin/Message.php HTTP/1.1
'User-Agent: Opera/7.11 (Windows NT 5.0; U)  [de]
'Host: 127.0.0.1:1500
'Accept: text/html, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1
'Accept-Language: de;q=1.0
'Accept-Charset: windows-1252, utf-8, utf-16, iso-8859-1;q=0.6, *;q=0.1
'Connection: Keep -Alive

End Function

Private Sub Class_Initialize()
c_Connection = "keep-alive"
c_Content_Length = 0
c_Content_Type = "text/plain"
c_ProtokollVersion = PROTOKOLLVERSION
c_User = LocalUser.cpUsername
c_MyIP = LocalUser.cpRemoteIP
c_Answer = True

End Sub

'Gesendetes Packet:

'POST /cgi-bin/AVBMMessenger.php?38029,9338541667 HTTP/1.1   <---- Umstellen aus 1.0
'Host: 127.0.0.1:1500
'User-Agent: AVBM/1.0
'Accept: */*
'Connection: keep-alive
'Content-Length: 113
'Content-Type: text/plain
'Proxy-Connection: keep-alive
'Pragma: no -cache

'Username: Kai
'ProtokollVersion: 0,8
'SocketCommand: Message for AVBM
'MyIP: 127.0.0.1
'DataAVBM:
'MSG|Text2|Kai

'Angekommenes Packet:

'POST /cgi-bin/AVBMMessenger.php?38029,9275694444 HTTP/1.0
'Host: 213.54.96.62:1500
'User-Agent: AVBM/1.0
'Accept: */*
'Content-Length: 121
'Content-Type: text/plain
'Pragma: no -Cache
'Cache -Control: Max -stale = 0
'Via: 1.0 cache6-ffm-vpn

'Username: Kai
'ProtokollVersion: 0,8
'SocketCommand: Message for AVBM
'MyIP: 213.54.96.62                 <----Fehler in clsWinSockHTTP
'DataAVBM:
'MSG|Text2|Kai

