Attribute VB_Name = "modWinsock"
'******************************************************************************
'*          Das dazugehrige Modul zur WinSock Klassen kombination
'*
'*          Hier kann man einige Konstanten Verndern
'*
'*      Erstellt fr ActiveVB Instant Messenger
'*      (c) 2003 Kai Liebenau
'*      Version: V 0.8.8
'*
'*  History:
'*
'*  Ver 0.8.8   - In Work
'*              - Errorhandling in GetHostByNameAlias gendert, ErrorCode mit als Rckgabe
'*  Ver 0.8.7   - Nothing
'*  Ver 0.8.6   - Nothing
'*  Ver 0.8.5   - Nothing
'*  Ver 0.8.4   - Konstante fr Protokollversion in eine Ganzzahl gendert
'*              - Konstante TIMEOUT_SENDDATA in Long gendert und Wert von 0.0002 in 1 gendert
'*              - Protokoll CMD "PROTOKOLL_UNKNOW_CMD" hinzugefgt
'*  Ver 0.8.3   - Nothing
'*  Ver 0.8.2   - Nothing
'*  Ver 0.8.1   - Nothing
'******************************************************************************

Option Explicit

'Konstanten Explicit fr den Messenger
Public Const TIMEOUT_SENDDATA               As Long = 1 'pro Byte
Public Const TIMEOUT_CONNECT                As Long = 30
Public Const TimeOut                        As Long = 200 '5 Sek
Public Const TIMEOUT_FILETRANSFER           As Long = 30 'Sek
Public Const TIMEOUT_RECONNECT              As Long = 10 'Sek
Public Const SOCKET_DEFAULT_PORT            As Long = 1500
Public Const HTTP_PORT                      As Long = 80
Public Const MAX_SOCKET                     As Long = 1000
Public Const PROTOKOLLVERSION               As Long = 1
Public Const CONNECTION_IDLE_TIME           As Long = 15 'Min
Public Const MIN_CONNECTIONS                As Long = 20 'Connections
Public Const FILE_CRYPT_HEADER              As Long = 37

Public m_ConnectionQuality                  As ConnectionQuality
Public m_FTSendBuffer                       As Long
Public m_FTSendMultipiller                  As Long
Public m_FTTransferCounter                  As Long
Public m_MAX_SOCKET                         As Long
Public m_SOCKET_DEFAULT_PORT                As Long

'allgemeine Messages
Public Const CONNECTION_CLOSED              As String = "ConnectionClosed"
Public Const CONNECTION_STILL_ALIVE         As String = "ConnectionStillAlive"
Public Const CONNECTION_STILL_MESSAGE       As String = "Connect for new Chat"
Public Const SOCKET_MAX_CONNECTION          As String = "Max Socket in use"
Public Const CONNECTION_STILL_REFUSE        As String = "Request Refused"
Public Const CONNECTION_STILL_ACCEPT        As String = "Request Accept"
Public Const CONNECTION_DOUBLE_CLOSE        As String = "Double Close"
Public Const PROTOKOLL_UNKNOW_CMD           As String = "Unknow PCMD"
'Routing Messages
Public Const ROUTING_FORWARD_TO             As String = "Forward Message to"
Public Const ROUTING_SEARCH_ROUTE_TO        As String = "Have Connection to"
Public Const ROUTING_FORWARDED              As String = "Message Forwarded"
Public Const ROUTING_FAILD                  As String = "Cant Routing"
Public Const ROUTING_NO_ROUTE               As String = "No Route found"
Public Const ROUTING_GATEWAY_OK             As String = "Route found by Broadcast"
Public Const CREATE_ROUTE_TO_LAN            As String = "Connect LAN Host and Route"
'Filetransfer Messages
Public Const FILETRANSFER_WILL_STARTING     As String = "Filetransfer will starting"
Public Const FILETRANSFER_ABORT             As String = "Filetransfer Abort"
Public Const FILETRANSFER_START             As String = "Filetransfer Start"
Public Const FILETRANSFER_OK                As String = "Filetransfer OK"
Public Const FILETRANSFER_NEXT              As String = "Filetransfer Next Part"
Public Const FILETRANSFER_COMPLETE          As String = "Filetransfer is Complete"
Public Const FILETRANSFER_RECONNECT         As String = "Filetransfer please Connect ME"
Public Const FILETRANSFER_RECONNECT_FAILD   As String = "Filetransfer Reconnect Faild"
Public Const FILETRANSFER_STILL_CONNECT     As String = "Filetransfer required Connection"
'Standartmessage, geht weiter zur GUI
Public Const AVBM_MESSAGE                   As String = "Message for AVBM"
'Broadcast Messages
Public Const FORWARD_BROADCAST_TO_NEW       As String = "Connect to New Con"
Public Const BROADCAST_CONNECT_TO           As String = "Broadcast Connect To Destination"
Public Const FORWARD_BROADCAST_TO           As String = "ForwardBroadcast to"
Public Const FORWARD_BROADCAST_FAILD        As String = "ForwardingFaild No Connection"
Public Const FORWARD_BROADCAST_OK           As String = "Broadcast forwarding"
'Proxy Messages
Public Const PROXY_GET_MESSAGE              As String = "Proxy Get Waitig MSG"
Public Const PROXY_NO_MORE_MESSAGE          As String = "Proxy NoWaiting MSG"

Public Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long

Public Enum ClientRoutingInfo
    ClientIsRouted
    ClientHasNotGateway
    ClientGatewayIsSearching
    ClientIsNotRouted
End Enum

Public Enum SocketLogModeEnum
    SOCKETLOG_INFO
    SOCKETLOG_INFO_EX
    SOCKETLOG_WARNING
    SOCKETLOG_WARNING_EX
    SOCKETLOG_ERROR
    SOCKETLOG_ERROR_EX
End Enum

Public Enum BufferState
    DataBuffered
    DataBufferOverflow
    DataComplete
End Enum

Public Enum ConnectionQuality
    Modem = 3000                ' 3KB/s
    ISDN = 7000                 ' 7KB/s
    ISDN2 = 15000               '15KB/s
    DSL384 = 7001               ' 7KB/s
    DSL768 = 15001              '15KB/s
    DSL1500 = 30000             '30KB/s
    Kabel3MBit = 60000          '60KB/s
    T1_Leitung = 1000000        ' 1MB/s
    T3_Leitung = 10000000       '10MB/s
End Enum

Public Type FLOWSPEC
    TokenRate As Long
    TokenBucketSize As Long
    PeakBandwidth As Long
    Latency As Long
    DelayVariation As Long
    ServiceType As Long 'SERVICETYPE
    MaxSduSize As Long
    MinimumPolicedSize As Long
End Type

'http://www.activevb.de/cgi-bin/messenger/messenger.pl
Public Const AVB_SITE               As String = "www.activevb.de"

Public m_IncomingStillConnection    As String
Public m_IncomingFilePath           As String
Public m_ProxyServer                As String
Public m_ProxyPort                  As Integer
Public m_ProxyOverride              As String
Public m_ProxyEnabled               As Boolean
Public m_NAT_Firewall_detected      As Boolean
Public m_NAT_Firewall_by_Setting    As Boolean
Public m_SendBuffer                 As Long
Public m_RecvBuffer                 As Long
Public m_SocketLogLevel             As Long
Public m_Forward_Broadcast_OK       As Long
Public m_lngSocketWindowhWnd        As Long
Public m_lngSocketMSG               As Long

Public Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)
Public Declare Function SetTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Public Declare Function GetCurrentProcessId Lib "kernel32.dll" () As Long

'Public Const FD_SETSIZE = 64

'Type fd_set
'    fd_count As Integer
'    fd_array(FD_SETSIZE) As Integer
'End Type

Public Type timeval
    tv_sec As Long
    tv_usec As Long
End Type

Type HostEnt
    h_name As Long
    h_aliases As Long
    h_addrtype As Integer
    h_length As Integer
    h_addr_list As Long
End Type
Public Const hostent_size = 16

Type servent
    s_name As Long
    s_aliases As Long
    s_port As Integer
    s_proto As Long
End Type
Public Const servent_size = 14

Type protoent
    p_name As Long
    p_aliases As Long
    p_proto As Integer
End Type
Public Const protoent_size = 10

Public Const IPPROTO_TCP = 6
Public Const IPPROTO_UDP = 17

Public Const INADDR_NONE = &HFFFFFFFF
Public Const INADDR_ANY = &H0

Public Type SockAddr
    sin_family As Integer
    sin_port As Integer
    sin_addr As Long
    sin_zero As String * 8
End Type

Public Const sockaddr_size = 16
Public saZero As SockAddr


Public Const WSA_DESCRIPTIONLEN = 256
Public Const WSA_DescriptionSize = WSA_DESCRIPTIONLEN + 1

Public Const WSA_SYS_STATUS_LEN = 128
Public Const WSA_SysStatusSize = WSA_SYS_STATUS_LEN + 1

Type WSADataType
    wVersion As Integer
    wHighVersion As Integer
    szDescription As String * WSA_DescriptionSize
    szSystemStatus As String * WSA_SysStatusSize
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpVendorInfo As Long
End Type

Public Const INVALID_SOCKET = -1
Public Const INVALID_PORT = -1
Public Const SOCKET_ERROR = -1

Public Const SOCK_STREAM = 1
Public Const SOCK_DGRAM = 2

Public Const MAXGETHOSTSTRUCT = 1024
Public Const MAX_RECIVEBUFFER = 4096

Public Const AF_INET = 2

Type LingerType
    l_onoff As Integer
    l_linger As Integer
End Type
' Windows Sockets definitions of regular Microsoft C error constants
Global Const WSAEINTR = 10004
Global Const WSAEBADF = 10009
Global Const WSAEACCES = 10013
Global Const WSAEFAULT = 10014
Global Const WSAEINVAL = 10022
Global Const WSAEMFILE = 10024
' Windows Sockets definitions of regular Berkeley error constants
Global Const WSAEWOULDBLOCK = 10035
Global Const WSAEINPROGRESS = 10036
Global Const WSAEALREADY = 10037
Global Const WSAENOTSOCK = 10038
Global Const WSAEDESTADDRREQ = 10039
Global Const WSAEMSGSIZE = 10040
Global Const WSAEPROTOTYPE = 10041
Global Const WSAENOPROTOOPT = 10042
Global Const WSAEPROTONOSUPPORT = 10043
Global Const WSAESOCKTNOSUPPORT = 10044
Global Const WSAEOPNOTSUPP = 10045
Global Const WSAEPFNOSUPPORT = 10046
Global Const WSAEAFNOSUPPORT = 10047
Global Const WSAEADDRINUSE = 10048
Global Const WSAEADDRNOTAVAIL = 10049
Global Const WSAENETDOWN = 10050
Global Const WSAENETUNREACH = 10051
Global Const WSAENETRESET = 10052
Global Const WSAECONNABORTED = 10053
Global Const WSAECONNRESET = 10054
Global Const WSAENOBUFS = 10055
Global Const WSAEISCONN = 10056
Global Const WSAENOTCONN = 10057
Global Const WSAESHUTDOWN = 10058
Global Const WSAETOOMANYREFS = 10059
Global Const WSAETIMEDOUT = 10060
Global Const WSAECONNREFUSED = 10061
Global Const WSAELOOP = 10062
Global Const WSAENAMETOOLONG = 10063
Global Const WSAEHOSTDOWN = 10064
Global Const WSAEHOSTUNREACH = 10065
Global Const WSAENOTEMPTY = 10066
Global Const WSAEPROCLIM = 10067
Global Const WSAEUSERS = 10068
Global Const WSAEDQUOT = 10069
Global Const WSAESTALE = 10070
Global Const WSAEREMOTE = 10071
' Extended Windows Sockets error constant definitions
Global Const WSASYSNOTREADY = 10091
Global Const WSAVERNOTSUPPORTED = 10092
Global Const WSANOTINITIALISED = 10093
Global Const WSAHOST_NOT_FOUND = 11001
Global Const WSATRY_AGAIN = 11002
Global Const WSANO_RECOVERY = 11003
Global Const WSANO_DATA = 11004
Global Const WSANO_ADDRESS = 11004
'---ioctl Constants
Public Const FIONREAD = &H8004667F
Public Const FIONBIO = &H8004667E
Public Const FIOASYNC = &H8004667D
'---Additional options.
Public Const SO_SNDBUF = &H1001&     ' Send buffer size.
Public Const SO_RCVBUF = &H1002&     ' Receive buffer size.
Public Const SO_ERROR = &H1007&      ' Get error status and clear.
Public Const SO_TYPE = &H1008&       ' Get socket type - READ-ONLY.
'---Socket Shutdown Params
Public Const SD_SEND As Long = &H1
Public Const SD_RECEIVE As Long = &H0
Public Const SD_BOTH As Long = &H2

'---Windows System Functions
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, src As Any, ByVal cb As Long)
Public Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Any) As Long
'---async notification constants
Public Enum NetworkEventID
    SOL_SOCKET = &HFFFF&
    SO_LINGER = &H80&
    FD_READ = &H1&
    FD_Write = &H2&
    FD_OOB = &H4&
    FD_ACCEPT = &H8&
    FD_CONNECT = &H10&
    FD_CLOSE = &H20&
End Enum
'---SOCKET FUNCTIONS
Public Declare Function API_Accept Lib "ws2_32.dll" Alias "accept" (ByVal s As Long, addr As SockAddr, addrlen As Long) As Long
Public Declare Function API_Bind Lib "ws2_32.dll" Alias "bind" (ByVal s As Long, addr As SockAddr, ByVal namelen As Long) As Long
Public Declare Function API_CloseSocket Lib "ws2_32.dll" Alias "closesocket" (ByVal s As Long) As Long
Public Declare Function API_Connect Lib "ws2_32.dll" Alias "connect" (ByVal s As Long, addr As SockAddr, ByVal namelen As Long) As Long
Public Declare Function ioctlsocket Lib "ws2_32.dll" (ByVal s As Long, ByVal cmd As Long, argp As Long) As Long
Public Declare Function API_GetPeerName Lib "ws2_32.dll" Alias "getpeername" (ByVal s As Long, sName As SockAddr, namelen As Long) As Long
Public Declare Function API_GetSockName Lib "ws2_32.dll" Alias "getsockname" (ByVal s As Long, sName As SockAddr, namelen As Long) As Long
Public Declare Function API_GetSockOpt Lib "ws2_32.dll" Alias "getsockopt" (ByVal s As Long, ByVal level As Long, ByVal optname As Long, optval As Any, optlen As Long) As Long
Public Declare Function htonl Lib "ws2_32.dll" (ByVal hostlong As Long) As Long
Public Declare Function htons Lib "ws2_32.dll" (ByVal hostshort As Long) As Integer
Public Declare Function inet_addr Lib "ws2_32.dll" (ByVal cp As String) As Long
Public Declare Function inet_ntoa Lib "ws2_32.dll" (ByVal inn As Long) As Long
Public Declare Function API_listen Lib "ws2_32.dll" Alias "listen" (ByVal s As Long, ByVal backlog As Long) As Long
Public Declare Function ntohl Lib "ws2_32.dll" (ByVal netlong As Long) As Long
Public Declare Function ntohs Lib "ws2_32.dll" (ByVal netshort As Long) As Integer
Public Declare Function API_Recive Lib "ws2_32.dll" Alias "recv" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Public Declare Function recvfrom Lib "ws2_32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long, From As SockAddr, fromlen As Long) As Long
'Public Declare Function ws_select Lib "ws2_32.dll" Alias "select" (ByVal nfds As Long, readfds As fd_set, writefds As fd_set, exceptfds As fd_set, TIMEOUT As timeval) As Long
Public Declare Function API_SocketSend Lib "ws2_32.dll" Alias "send" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long) As Long
Public Declare Function sendto Lib "ws2_32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, ByVal flags As Long, to_addr As SockAddr, ByVal tolen As Long) As Long
Public Declare Function setsockopt Lib "ws2_32.dll" (ByVal s As Long, ByVal level As Long, ByVal optname As Long, optval As Any, ByVal optlen As Long) As Long
Public Declare Function API_ShutDown Lib "ws2_32.dll" Alias "shutdown" (ByVal s As Long, ByVal how As Long) As Long
Public Declare Function socket Lib "ws2_32.dll" (ByVal af As Long, ByVal s_type As Long, ByVal protocol As Long) As Long
'---DATABASE FUNCTIONS
Public Declare Function gethostbyaddr Lib "ws2_32.dll" (addr As Long, ByVal addr_len As Long, ByVal addr_type As Long) As Long
Public Declare Function gethostbyname Lib "ws2_32.dll" (ByVal host_name As String) As Long
Public Declare Function gethostname Lib "ws2_32.dll" (ByVal host_name As String, ByVal namelen As Long) As Long
Public Declare Function getservbyport Lib "ws2_32.dll" (ByVal Port As Long, ByVal proto As String) As Long
Public Declare Function getservbyname Lib "ws2_32.dll" (ByVal serv_name As String, ByVal proto As String) As Long
Public Declare Function getprotobynumber Lib "ws2_32.dll" (ByVal proto As Long) As Long
Public Declare Function getprotobyname Lib "ws2_32.dll" (ByVal proto_name As String) As Long
'---WINDOWS EXTENSIONS
Public Declare Function WSAAccept Lib "ws2_32.dll" (ByVal s As Long, ByRef addr As SockAddr, ByRef addrlen As Long, ByVal lpfnCondition As Long, ByVal dwCallbackData As Long) As Long
Public Declare Function WSARecvEx Lib "ws2_32.dll" (ByVal s As Long, buf As Any, ByVal buflen As Long, flags As Long) As Long

Public Declare Function WSAStartup Lib "ws2_32.dll" (ByVal wVR As Long, lpWSAD As WSADataType) As Long
Public Declare Function WSACleanup Lib "ws2_32.dll" () As Long
Public Declare Sub WSASetLastError Lib "ws2_32.dll" (ByVal iError As Long)
Public Declare Function WSAGetLastError Lib "ws2_32.dll" () As Long
Public Declare Function WSAUnhookBlockingHook Lib "ws2_32.dll" () As Long
Public Declare Function WSASetBlockingHook Lib "ws2_32.dll" (ByVal lpBlockFunc As Long) As Long
Public Declare Function WSAAsyncGetServByName Lib "ws2_32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal serv_name As String, ByVal proto As String, buf As Any, ByVal buflen As Long) As Long
Public Declare Function WSAAsyncGetServByPort Lib "ws2_32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal Port As Long, ByVal proto As String, buf As Any, ByVal buflen As Long) As Long
Public Declare Function WSAAsyncGetProtoByName Lib "ws2_32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal proto_name As String, buf As Any, ByVal buflen As Long) As Long
Public Declare Function WSAAsyncGetProtoByNumber Lib "ws2_32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal Number As Long, buf As Any, ByVal buflen As Long) As Long
Public Declare Function WSAAsyncGetHostByName Lib "ws2_32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal host_name As String, buf As Any, ByVal buflen As Long) As Long
Public Declare Function WSAAsyncGetHostByAddr Lib "ws2_32.dll" (ByVal hwnd As Long, ByVal wMsg As Long, addr As Long, ByVal addr_len As Long, ByVal addr_type As Long, buf As Any, ByVal buflen As Long) As Long
Public Declare Function WSACancelAsyncRequest Lib "ws2_32.dll" (ByVal hAsyncTaskHandle As Long) As Long
Public Declare Function WSAAsyncSelect Lib "ws2_32.dll" (ByVal s As Long, ByVal hwnd As Long, ByVal wMsg As Long, ByVal lEvent As NetworkEventID) As Long
Public Declare Function WSAConnect Lib "ws2_32.dll" (ByVal s As Long, ByRef name As SockAddr, ByVal namelen As Long, ByVal lpCallerData As String, ByVal lpCalleeData As Long, ByRef lpSQOS As FLOWSPEC, ByVal lpGQOS As Long) As Long

Public Declare Sub CopyMem Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, _
                     ByVal idEvent As Long, ByVal dwTime As Long)
    'modConnection.MyConnection.HeartBeat
    DoEvents
End Sub
Public Function AddrToIP(ByVal AddrOrIP As String) As String
    AddrToIP = GetAscIP(GetHostByNameAlias(AddrOrIP))
End Function
Public Function GetAscIP(ByVal inn As Long) As String
    Dim nStr As Long
    Dim lpStr As Long
    Dim retString As String
    
    lpStr = inet_ntoa(inn)
    If lpStr Then
        nStr = lstrlen(lpStr)
        retString = String$(nStr, 0)
        If nStr > 32 Then nStr = 32
        MemCopy ByVal retString, ByVal lpStr, nStr
        retString = Left$(retString, nStr)
        GetAscIP = retString
    Else
        GetAscIP = "255.255.255.255"
    End If
End Function


Public Function GetHostByNameAlias(ByVal HostName As String, Optional lErr As Long) As Long
'Return IP address as a long, in network byte order
    Dim phe As Long
    Dim heDestHost As HostEnt
    Dim addrList As Long
    Dim retIP As Long
    retIP = inet_addr(HostName)
    If retIP = INADDR_NONE Then
        phe = gethostbyname(HostName)
        lErr = Err.LastDllError
        If phe <> 0 Then
            MemCopy heDestHost, ByVal phe, hostent_size
            MemCopy addrList, ByVal heDestHost.h_addr_list, 4
            MemCopy retIP, ByVal addrList, heDestHost.h_length
        Else
            retIP = INADDR_NONE
        End If
    End If
    GetHostByNameAlias = retIP
End Function
Function GetWSAErrorString(ByVal errnum As Long) As String
    On Error Resume Next
    Select Case errnum
        Case 0: GetWSAErrorString = vbNullString
        Case 10004: GetWSAErrorString = "Interrupted system call."
        Case 10009: GetWSAErrorString = "Bad file number."
        Case 10013: GetWSAErrorString = "Permission Denied."
        Case 10014: GetWSAErrorString = "Bad Address."
        Case 10022: GetWSAErrorString = "Invalid Argument."
        Case 10024: GetWSAErrorString = "Too many open files."
        Case 10035: GetWSAErrorString = "Operation would block."
        Case 10036: GetWSAErrorString = "Operation now in progress."
        Case 10037: GetWSAErrorString = "Operation already in progress."
        Case 10038: GetWSAErrorString = "Socket operation on nonsocket."
        Case 10039: GetWSAErrorString = "Destination address required."
        Case 10040: GetWSAErrorString = "Message too long."
        Case 10041: GetWSAErrorString = "Protocol wrong type for socket."
        Case 10042: GetWSAErrorString = "Protocol not available."
        Case 10043: GetWSAErrorString = "Protocol not supported."
        Case 10044: GetWSAErrorString = "Socket type not supported."
        Case 10045: GetWSAErrorString = "Operation not supported on socket."
        Case 10046: GetWSAErrorString = "Protocol family not supported."
        Case 10047: GetWSAErrorString = "Address family not supported by protocol family."
        Case 10048: GetWSAErrorString = "Address already in use."
        Case 10049: GetWSAErrorString = "Can't assign requested address."
        Case 10050: GetWSAErrorString = "Network is down."
        Case 10051: GetWSAErrorString = "Network is unreachable."
        Case 10052: GetWSAErrorString = "Network dropped connection."
        Case 10053: GetWSAErrorString = "Software caused connection abort."
        Case 10054: GetWSAErrorString = "Connection reset by peer."
        Case 10055: GetWSAErrorString = "No buffer space available."
        Case 10056: GetWSAErrorString = "Socket is already connected."
        Case 10057: GetWSAErrorString = "Socket is not connected."
        Case 10058: GetWSAErrorString = "Can't send after socket shutdown."
        Case 10059: GetWSAErrorString = "Too many references: can't splice."
        Case 10060: GetWSAErrorString = "Connection timed out."
        Case 10061: GetWSAErrorString = "Connection refused."
        Case 10062: GetWSAErrorString = "Too many levels of symbolic links."
        Case 10063: GetWSAErrorString = "File name too long."
        Case 10064: GetWSAErrorString = "Host is down."
        Case 10065: GetWSAErrorString = "No route to host."
        Case 10066: GetWSAErrorString = "Directory not empty."
        Case 10067: GetWSAErrorString = "Too many processes."
        Case 10068: GetWSAErrorString = "Too many users."
        Case 10069: GetWSAErrorString = "Disk quota exceeded."
        Case 10070: GetWSAErrorString = "Stale NFS file handle."
        Case 10071: GetWSAErrorString = "Too many levels of remote in path."
        Case 10091: GetWSAErrorString = "Network subsystem is unusable."
        Case 10092: GetWSAErrorString = "Winsock DLL cannot support this application."
        Case 10093: GetWSAErrorString = "Winsock not initialized."
        Case 10101: GetWSAErrorString = "Disconnect."
        Case 11001: GetWSAErrorString = "Host not found."
        Case 11002: GetWSAErrorString = "Nonauthoritative host not found."
        Case 11003: GetWSAErrorString = "Nonrecoverable error."
        Case 11004: GetWSAErrorString = "Valid name, no data record of requested type."
        Case Else: GetWSAErrorString = "Unknow Error occoured"
    End Select
End Function

