VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSystemTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Declares
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean
Private Declare Function ShowWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Const SW_HIDE As Long = 0
Private Const GWL_EXSTYLE As Long = -20
Private Const WS_EX_APPWINDOW As Long = &H40000
Private Const SW_SHOW As Long = 5

'Typen
Private Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformID As Long
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    UID As Long
    uFlags As Long
    uCallBackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

'Konstanten
'Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2

Private Const WM_MOUSEMOVE = &H200

Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

'Private Const WM_LBUTTONDBLCLK = &H203   'Double-click
'Private Const WM_LBUTTONDOWN = &H201     'Button down
'Private Const WM_LBUTTONUP = &H202       'Button up

'Private Const WM_RBUTTONDBLCLK = &H206   'Double-click
'Private Const WM_RBUTTONDOWN = &H204     'Button down
'Private Const WM_RBUTTONUP = &H205       'Button up

Dim nid As NOTIFYICONDATA
Dim Ver As OSVERSIONINFO, OS As String, rv As Long

Private m_blnSysIconExists As Boolean

Public Sub SysVersion()
    Ver.dwOSVersionInfoSize = Len(Ver)
             
    rv = GetVersionEx(Ver)
    'Ver.dwPlatformId = 0
    Select Case Ver.dwPlatformID
        Case VER_PLATFORM_WIN32_WINDOWS
            OS = "Windows 9x"
        Case VER_PLATFORM_WIN32_NT
            OS = "Windows NT"
    End Select
End Sub

Property Get OSVersion() As String
    OSVersion = OS
End Property
Property Get OSBuild() As Long
    OSBuild = Ver.dwBuildNumber
End Property

Public Sub InitSystray(hIcon As Long, OwnerHwnd As Long)
    nid.cbSize = Len(nid)
    nid.hwnd = OwnerHwnd
    nid.UID = vbNull
    nid.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    nid.uCallBackMessage = WM_MOUSEMOVE
    nid.hIcon = hIcon
    nid.szTip = App.ProductName & vbNullChar
    
    Shell_NotifyIcon NIM_ADD, nid
    m_blnSysIconExists = True
End Sub

Public Sub DeleteSystray(OwnerHwnd As Long)
    If m_blnSysIconExists Then
        nid.cbSize = Len(nid)
        nid.hwnd = OwnerHwnd
        Shell_NotifyIcon NIM_DELETE, nid
        m_blnSysIconExists = False
    End If
End Sub

Public Sub SetTrayIconData(ToolTipText As String, Icon As Long, Optional OwnerHwnd As Long = 0)
    If m_blnSysIconExists Then
        nid.cbSize = Len(nid)
        If OwnerHwnd <> 0 Then nid.hwnd = OwnerHwnd
        nid.UID = vbNull
        nid.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        nid.uCallBackMessage = WM_MOUSEMOVE
        nid.hIcon = Icon
        nid.szTip = ToolTipText & vbNullChar
        Shell_NotifyIcon NIM_MODIFY, nid
    End If
End Sub

' Anwendung/Fenster in Taskbar anzeigen/verstecken
' (ShowInTaskBar = schreibgeschtzt zur Laufzeit!)
Public Sub ShowMeInTaskBar(ByVal hForm As Form, ByVal OnOff As Boolean, Optional ByVal AusAn As Boolean = True)
    Dim rApi As Long
    '
    If AusAn Then rApi = ShowWindow(hForm.hwnd, SW_HIDE)              ' Fenster kurz ausblenden damit die
    DoEvents                                            ' nderungen greifen!
    ' Fenster-Stil ndern
    If OnOff = False Then
        rApi = SetWindowLong(hForm.hwnd, GWL_EXSTYLE, (GetWindowLong(hForm.hwnd, _
                                                       GWL_EXSTYLE) And Not WS_EX_APPWINDOW))
    Else
        rApi = SetWindowLong(hForm.hwnd, GWL_EXSTYLE, (GetWindowLong(hForm.hwnd, _
                                                       GWL_EXSTYLE) Or WS_EX_APPWINDOW))
    End If
    '
    If AusAn Then rApi = ShowWindow(hForm.hwnd, SW_SHOW)              'Fenster wieder anzeigen
    DoEvents
End Sub

Private Sub Class_Initialize()
    Call Me.SysVersion
End Sub


