Attribute VB_Name = "modChat"
Option Explicit

Public Type SmileyData
   sdFilename As String
   sdKey(0 To 1) As String
End Type

Public Smilies() As SmileyData

Public ChatWindows  As Collection
'----------------------------------------------------

Public colUsername As Long
Public colOwnUsername As Long
Public colChatMessage As Long
Public colSystemMessage As Long
Public colDate As Long
Public colMessageLink As Long

Public MaxHistoryLength As Long

Public dirSmilies As String

Public Sub SetColors()
   colUsername = RGB(50, 90, 150)
   colOwnUsername = RGB(120, 160, 210)
   colChatMessage = RGB(50, 50, 50)
   colSystemMessage = RGB(180, 180, 180)
   colDate = RGB(250, 0, 0)
   colMessageLink = RGB(0, 0, 200)

   MaxHistoryLength = 256

End Sub

Public Sub InitSmilies()
   Dim i As Long
   
   dirSmilies = CorrectPath(App.Path) & "smilies\"
   ReDim Smilies(27)
   
   For i = 0 To UBound(Smilies)
      Smilies(i).sdFilename = dirSmilies & "smiley" & Format$(i + 1, "00") & ".gif"
   Next i

   Smilies(0).sdKey(0) = ":-)": Smilies(0).sdKey(1) = ":)"
   Smilies(1).sdKey(0) = ":-(": Smilies(1).sdKey(1) = ":("
   Smilies(2).sdKey(0) = ";-)": Smilies(2).sdKey(1) = ";)"
   Smilies(3).sdKey(0) = ">)"
   Smilies(4).sdKey(0) = ":-D": Smilies(4).sdKey(1) = ":D"
   Smilies(5).sdKey(0) = "B-)": Smilies(5).sdKey(1) = "8-)"
   Smilies(6).sdKey(0) = ":'(": Smilies(6).sdKey(1) = ":'-("
   Smilies(7).sdKey(0) = ":-*"
   Smilies(8).sdKey(0) = ":-P"
   Smilies(9).sdKey(0) = ":-O"
   Smilies(10).sdKey(0) = ":-|": Smilies(10).sdKey(1) = ":|"
   Smilies(11).sdKey(0) = "-.-"
   Smilies(12).sdKey(0) = ":-/"
   Smilies(13).sdKey(0) = "})"
   Smilies(14).sdKey(0) = "*shamed*"
   Smilies(15).sdKey(0) = "o.O"
   Smilies(16).sdKey(0) = "*sighing*"
   Smilies(17).sdKey(0) = ":-X"
   Smilies(18).sdKey(0) = "X-)"
   Smilies(19).sdKey(0) = "*angry*"
   Smilies(20).sdKey(0) = "$-)"
   Smilies(21).sdKey(0) = "*inlove*"
   Smilies(22).sdKey(0) = ":-S"
   Smilies(23).sdKey(0) = "_"
   Smilies(24).sdKey(0) = "*???*"
   Smilies(25).sdKey(0) = "^_^"
   Smilies(26).sdKey(0) = ";-D"
   Smilies(27).sdKey(0) = "==)"

End Sub

Public Sub LogChatMessage(NickName As String, ByVal Message As String, From As String, MessageTime As String)
   On Local Error GoTo ErrorHandler
   Dim FileName As String
   Dim filNo As Integer
   
   If NickName = "" Then Exit Sub
   
   Call MakeSureDirectoryPathExists(dirMessageHistory)
   
   Message = Replace(Message, vbCrLf, "\n")
   
   FileName = dirMessageHistory & CorrectFilename(NickName) & ".txt"
   filNo = FreeFile

   If Not FileExists(FileName) Then
      'create history file'
      filNo = FreeFile
      Open FileName For Output As filNo: Close #filNo
   End If

   'read hisory data'
   Open FileName For Append As filNo
      Print #filNo, Format$(Now, "dd.mm.yyyy") & " " & MessageTime & " " & From & vbTab & vbTab & Message
   Close #filNo

   Exit Sub
   
ErrorHandler:
   On Local Error Resume Next
   Close #filNo

End Sub

Public Function GetCode(FileName As String) As String
   On Local Error GoTo ErrorHandler
   Dim FileContent As String
   Dim filNo As Integer

   filNo = FreeFile
   Open FileName For Binary Access Read As #filNo
      FileContent = Space$(LOF(filNo))
      Get #filNo, , FileContent
   Close #filNo

   GetCode = FileContent

   Exit Function

ErrorHandler:
   On Local Error Resume Next
   Close #filNo

End Function

'----------------------------------------------------

Public Sub SetChatProperties(SecondaryLAN_IP As String, SecondaryRemoteIP As String, SecondaryNick As String, PrimaryLAN_IP As String, PrimaryRemoteIP As String, PrimaryNick As String, ChatId As String)
   Dim ChatWindow As dlgChat
   Dim FoundChatWindow As Boolean

   'search exist chat window'
   If Not dlgMain.CreateConnection.ExistChatWindow(ChatId) Then
      FoundChatWindow = False
      For Each ChatWindow In ChatWindows
         If LCase$(ChatWindow.LastChatNick) = LCase$(PrimaryNick) Then
            Set ChatWindow = ChatWindows(ChatWindow.ChatId)
            FoundChatWindow = True
            Exit For
         End If
      Next ChatWindow
       
      If Not FoundChatWindow Then
         Set ChatWindow = New dlgChat
         Call ChatWindow.Hide
         If Not dlgMain.CreateConnection.ExistChatWindow(ChatId) Then
            Call ChatWindows.Add(ChatWindow, ChatId)
         End If
      Else
         Call ChatWindows.Remove(ChatWindow.ChatId)
         ChatWindow.ChatId = ChatId
         Call ChatWindows.Add(ChatWindow, ChatId)
      End If
   
   Else
      Set ChatWindow = ChatWindows(ChatId)
   
   End If
   
   Call ChatWindow.SetSecondaryHost(SecondaryNick, SecondaryRemoteIP, SecondaryLAN_IP)
   Call ChatWindow.SetPrimaryHost(PrimaryNick, PrimaryRemoteIP, PrimaryLAN_IP)

End Sub

Public Sub GotChatInvitation(PrimaryLAN_IP As String, PrimaryRemoteIP As String, PrimaryNick As String, ChatId As String)

   If LocalUser.cpOnlineState = cosBusy Then
      'not available for multichat. ignore request'
      Exit Sub
   End If

   'connect to chat'
   Call dlgMain.CreateConnection.ConnectClient(PrimaryNick, PrimaryRemoteIP, PrimaryLAN_IP, ChatId, True, , False)

End Sub

Public Sub AddClientToConference(NickName As String, RemoteIP As String, ChatId As String)
   Dim ChatWindow As dlgChat

   If LCase$(NickName) = LCase$(LocalUser.cpUsername) Then Exit Sub

   'set user state'
   If dlgMain.ClientManagement.GetClientOnlineState(NickName) <= cosOffline Then _
       Call dlgMain.ClientManagement.SetClient(NickName, RemoteIP)

   'add client to conference'
   Set ChatWindow = ChatWindows.Item(ChatId)
   Call ChatWindow.AddConferenceClient(NickName, RemoteIP)

End Sub

Public Sub RemoveClientFromConference(NickName As String, ChatId As String)
   Dim ChatWindow As dlgChat

   If Not dlgMain.CreateConnection.ExistChatWindow(ChatId) Then Exit Sub

   'remove client from conference'
   Set ChatWindow = ChatWindows.Item(ChatId)
   Call ChatWindow.RemoveConferenceClient(NickName)

   If LCase$(ChatWindow.PrimaryHostName) = LCase$(LocalUser.cpUsername) Then
      'send new client list to each client'
      Call ChatWindow.AnnounceClientState(NickName, "", False)
   
      'check secondary host'
      If LCase$(ChatWindow.SecondaryHostName) = LCase$(NickName) Then
         'secondary host leaves the chat'
         Call ChatWindow.SetNewHost(2)
      End If
         
   ElseIf LCase$(ChatWindow.SecondaryHostName) = LCase$(LocalUser.cpUsername) Then
      'check primary host'
      If LCase$(ChatWindow.PrimaryHostName) = LCase$(NickName) Then
         'primary host leaves the chat'
         Call ChatWindow.SetNewHost(1)
      End If
   
   End If

End Sub
