Attribute VB_Name = "modCredits"
Option Explicit

'**********************************************************
'*  Modul zum Anzeigen von Credits
'*
'*  Erstellt von Bjrn Tschrtner (bat_ware@surfeu.de)
'*  Letzte nderung: 26.02.2004
'*  Version: 1.0
'**********************************************************

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function AlphaBlend Lib "msimg32.dll" (ByVal hDCDest As Long, ByVal nXOriginDest As Long, ByVal nYOriginDest As Long, ByVal nWidthDest As Long, ByVal nHeightDest As Long, ByVal hdcSrc As Long, ByVal nXOriginSrc As Long, ByVal nYOriginSrc As Long, ByVal nWidthSrc As Long, ByVal nHeightSrc As Long, ByVal BlendFunction As Long) As Long

Const DT_CENTER As Long = &H1
Const DT_CALCRECT As Long = &H400

Dim IsRunning As Boolean
Dim CreditsData() As String

Public Sub ClearCredits()
   Erase CreditsData
   ReDim CreditsData(0)
End Sub

Public Sub AddCreditData(Text As String)
   Dim newDataIndex As Long
   newDataIndex = UBound(CreditsData) + 1
   ReDim Preserve CreditsData(newDataIndex)
   Text = Replace(Text, "\n", vbCrLf)
   CreditsData(newDataIndex) = Text
End Sub

Public Sub StopCredits()
   IsRunning = False
End Sub

Public Sub RunCredits(dstPicture As PictureBox, TextPicture As PictureBox)
   Dim CreditIndex As Long
   Dim TextFrame As RECT
   Dim posX As Long, posY As Long
   Dim Alpha As Long
   Dim curText As String
   Dim StartTime As Double
   Dim difCenter As Long
   Dim TimeWait As Double
   
   If IsRunning Then Exit Sub
   IsRunning = True
   
   'set default font'
   TextPicture.FontName = "Tahoma"
   TextPicture.FontSize = 10
   TextPicture.FontBold = True
   TextPicture.ForeColor = RGB(50, 90, 150)
   
   For CreditIndex = 1 To UBound(CreditsData)
   
      TextPicture.Cls
      TextPicture.FontUnderLine = False
      TextPicture.FontItalic = False
   
      'set text format'
      If Left$(CreditsData(CreditIndex), 2) = "\u" Then
         TextPicture.FontUnderLine = True
         curText = Right$(CreditsData(CreditIndex), Len(CreditsData(CreditIndex)) - 2)
      ElseIf Left$(CreditsData(CreditIndex), 2) = "\i" Then
         TextPicture.FontItalic = True
         curText = Right$(CreditsData(CreditIndex), Len(CreditsData(CreditIndex)) - 2)
      Else
         curText = CreditsData(CreditIndex)
      End If
               
      'set text to center'
      TextFrame.Left = 0
      TextFrame.Top = 0
      Call DrawText(TextPicture.hdc, curText, Len(curText), TextFrame, DT_CALCRECT Or DT_CENTER)
      TextPicture.Width = (TextFrame.Right + 1) * m_lngTwipsPerPixelX
      TextPicture.Height = (TextFrame.Bottom + 2) * m_lngTwipsPerPixelY
      posX = (dstPicture.ScaleWidth / 2) - (TextPicture.ScaleWidth / 2)
      posY = (dstPicture.ScaleHeight / 2) - (TextPicture.ScaleHeight / 2)
                 
      TimeWait = Round((Len(curText) / 200), 1)
      
      'fade in'
      StartTime = Timer
      Do
         Alpha = (255 / 2) * (Timer - StartTime)
         If Alpha < 0 Then Alpha = 0
         If Alpha > 255 Then Alpha = 255
         
         difCenter = ((dstPicture.ScaleWidth / 0.4) / 2) * (Timer - StartTime)
         If difCenter > dstPicture.ScaleWidth / 2 Then difCenter = dstPicture.ScaleWidth / 2
         
         dstPicture.Cls
         
         'from left'
         Call BitBlt(TextPicture.hdc, 0, 0, TextPicture.ScaleWidth, TextPicture.ScaleHeight, dstPicture.hdc, posX, posY, vbSrcCopy)
         Call DrawText(TextPicture.hdc, curText, Len(curText), TextFrame, DT_CENTER)
         Call SetText(posX - (dstPicture.ScaleWidth / 2) + difCenter, posY, dstPicture, TextPicture, CByte(Alpha))
         
         'from right'
         Call BitBlt(TextPicture.hdc, 0, 0, TextPicture.ScaleWidth, TextPicture.ScaleHeight, dstPicture.hdc, posX, posY, vbSrcCopy)
         Call DrawText(TextPicture.hdc, curText, Len(curText), TextFrame, DT_CENTER)
         Call SetText(posX + (dstPicture.ScaleWidth / 2) - difCenter, posY, dstPicture, TextPicture, CByte(Alpha))
         
         TextPicture.Refresh
         DoEvents
         Call Sleep(1)
         
         If IsRunning = False Then Exit For
      Loop Until Timer - StartTime >= 2 + TimeWait
            
      'cancel'
      If IsRunning = False Then Exit For
      'exit on last entry'
      If CreditIndex >= UBound(CreditsData) Then Exit For
            
      'fade out'
      StartTime = Timer
      Do
'         TimeWait = Timer - StartTime
         Alpha = 255 - ((255 / 1) * (Timer - StartTime))
         If Alpha < 0 Then Alpha = 0
         If Alpha > 255 Then Alpha = 255
         
         dstPicture.Cls
         
         Call SetText((dstPicture.ScaleWidth / 2) - (TextPicture.ScaleWidth / 2), (dstPicture.ScaleHeight / 2) - (TextPicture.ScaleHeight / 2), dstPicture, TextPicture, CByte(Alpha))
         
         TextPicture.Refresh
         DoEvents
         Call Sleep(1)
         
         If IsRunning = False Then Exit For
      Loop Until Timer - StartTime >= 1
      
      'cancel'
      If IsRunning = False Then Exit For
   
   Next CreditIndex

   IsRunning = False

End Sub

Private Sub SetText(posX As Long, posY As Long, dstPicture As PictureBox, TextPicture As PictureBox, Alpha As Byte)
   Dim lngBlendInfo As Long
   lngBlendInfo = CLng(Alpha) * &H10000
   Call AlphaBlend( _
      dstPicture.hdc, _
      posX, _
      posY, _
      TextPicture.ScaleWidth, _
      TextPicture.ScaleHeight, _
      TextPicture.hdc, _
      0, _
      0, _
      TextPicture.ScaleWidth, _
      TextPicture.ScaleHeight, _
      lngBlendInfo _
   )
End Sub

