Attribute VB_Name = "modCrypt"
Option Base 0
Option Explicit
Option Compare Text


' Calls the ASM-routines. The parameters
' depend on the special function called.
Private Declare Function ASM_cdRF3 _
    Lib "user32" Alias "CallWindowProcA" _
   (ByRef asm As Long, _
    ByRef PA1 As Long, _
    ByRef PA2 As Long, _
    ByVal PA3 As Long, _
    ByVal PA4 As Long) As Long

' Copies memory blocks
Private Declare Sub API_CopyByRef _
    Lib "kernel32" Alias "RtlMoveMemory" _
   (ByRef hpvDest As Any, _
    ByRef hpvSource As Any, _
    ByVal cbCopy As Long)


Public Keys                     As New CKeys
Public Const CRYPTO_HEADER      As String = "CRYPTED_"

Public Const Base64             As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

Public B64()                    As Byte
Public Rev64(122)               As Byte

Public Type KeyValueType
    p       As Long
    G       As Long
    a       As Long
    Alpha   As Long
    beta    As Long
    k       As Long
End Type
'----------------------------------------------------

Function byteArray_to_string(ByRef bArray() As Byte) As String
   byteArray_to_string = StrConv(bArray, vbUnicode)
End Function

Sub String_to_byteArray(ByRef Source As String, ByRef bArray() As Byte)
    bArray() = StrConv(Source, vbFromUnicode)
End Sub

' LNG2CHR   Convert longs to string (*)
'
' CALL:     LNG2CHR(src, [bnd], [flg:Cnv2Unicode])
'
' IN:       ptr:src Long v longarray
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'           bol:flg .T.: Convert to unicode (dflt)
'                   .F.: Do not convert to unicode
'
' OUT:      chr     chr converted array
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for src:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'
' Caution:  The unicode conversion does not only include a zero
'           after each character (i.E. &H91 becomes 12 20). This
'           may cause differences between the strings and the
'           longs. Hence, you must re-convert the string returned
'           to ansi before using it.
' Copyright by Udo Schmidt
Function LNG2CHR( _
    src As Long, _
    Optional bnd As Long = 0, _
    Optional Cnv2Unicode As Boolean = True) As String

    Dim bar() As Byte

    ReDim bar(bnd * 4 + 3)
    API_CopyByRef ByVal VarPtr(bar(0)), src, UBound(bar) + 1

    If Cnv2Unicode Then
        LNG2CHR = StrConv(bar, vbUnicode)
    Else
        LNG2CHR = bar
    End If
End Function

' lngCMP    Compare longs (*)
'
' CALL:     lngCMP(pa1, pa2, [bnd], [@pos])
'
' IN:       ptr:pa1 Long v longarray
'           ptr:pa2 Long v longarray
'           lng:bnd Bound - zerobased loopcount (dflt=0)
'           lng:pos Placeholder for position of first difference
'
' OUT:      bol     .T.: pa1=pa2  (pos = unchanged)
'                   .F.: pa1<>pa2 (pos = first difference)
'
' Hints:    - Since VB always passes pointers, you may use simple
'             longs as well as arrays and immediates for pa1/pa2:
'             I1, J1 ... I1(0), J1(x) ... &H80000000, 4711 ...
'           - A simple compare command was lngCMP(V1, V2), but
'             this could be fullfilled much faster via If V1=V2, so
'             this function is really made for to compare arrays
' Copyright by Udo Schmidt
Function lngCMP( _
    PA1 As Long, _
    PA2 As Long, _
    Optional bnd As Long = 0, _
    Optional pos As Long) As Boolean

    Static asm(10) As Long

    If asm(0) = 0 Then
        asm(0) = &H748B5756:  asm(1) = &H7C8B0C24:  asm(2) = &H4C8B1024
        asm(3) = &HF3411424:  asm(4) = &HFF418DA7:  asm(5) = &H442B0E74
        asm(6) = &HD0F71424:  asm(7) = &H18247C8B:  asm(8) = &HC0330789
        asm(9) = &H10C25E5F:  asm(10) = &H0
    End If

    ' *******************************************************************

    lngCMP = ASM_cdRF3(asm(0), PA1, PA2, bnd, VarPtr(pos))
End Function

Public Function Base64Encode(Source As String) As String

    Dim I1          As Long, _
        Length      As Long, _
        k           As Long, _
        Rest        As Long, _
        W(4)        As Integer, _
        SourceB()   As Byte, _
        Result()    As Byte
    
    Length = Len(Source)
    If Length = 0 Then _
        Exit Function
        
    SourceB() = StrConv(Source, vbFromUnicode)
    
    Rest = Length Mod 3
    If Rest > 0 Then
        Length = ((Length \ 3) + 1) * 3
        ReDim Preserve SourceB(Length - 1)
    End If
    
    ReDim Result(4 * Length / 3 - 1)        ' Das Ergebnis ist 4/3 mal so lang
    
    For I1 = 0 To (Length / 3 - 1)
        k = 3 * I1
        
        W(1) = Int(SourceB(k) / 4)
        W(2) = (SourceB(k) And 3) * 16 + Int(SourceB(k + 1) / 16)
        W(3) = (SourceB(k + 1) And 15) * 4 + Int(SourceB(k + 2) / 64)
        W(4) = SourceB(k + 2) And 63
          
        k = 4 * I1
        Result(k) = B64(W(1))
        Result(k + 1) = B64(W(2))
        Result(k + 2) = B64(W(3))
        Result(k + 3) = B64(W(4))
    
    Next I1
    
    Select Case Rest
        Case 1
            Result(UBound(Result)) = 61
            Result(UBound(Result) - 1) = 61
        Case 2
            Result(UBound(Result)) = 61
    End Select
    
    Base64Encode = StrConv(Result, vbUnicode)
End Function

Function Base64Decode(Source As String) As String
    Dim I1          As Long, _
        Length      As Long, _
        Rest        As Long, _
        cnt         As Long, _
        SourceB()   As Byte, _
        Result()    As Byte
    
    Length = Len(Source$)
    
    If Length = 0 Then _
        Exit Function
    
    Rest = Length Mod 4
    If Rest > 0 Then
        Source$ = Source$ + String$(4 - Rest, 0)
        Length = Len(Source$)
    End If
    
    SourceB() = StrConv(Source, vbFromUnicode)
    ReDim Result(Length)
   
    For I1 = 0 To UBound(SourceB) Step 4
        Result(cnt) = ((Rev64(SourceB(I1)) * 4 + Int(Rev64(SourceB(I1 + 1)) / 16)) And 255)
        Result(cnt + 1) = ((Rev64(SourceB(I1 + 1)) * 16 + Int(Rev64(SourceB(I1 + 2)) / 4)) And 255)
        Result(cnt + 2) = ((Rev64(SourceB(I1 + 2)) * 64 + Rev64(SourceB(I1 + 3))) And 255)
        cnt = cnt + 3
    Next
   
    If InStr(1, Source, "=") > 0 Then _
        cnt = cnt - (Rest + Len(Source) - InStr(1, Source, "=") + 1)

    ReDim Preserve Result(cnt - 1)
    Base64Decode = StrConv(Result, vbUnicode)
End Function

Public Sub InitBase64(Code As String)
    Dim I1      As Long
    
    B64() = StrConv(Code, vbFromUnicode)
    For I1 = 0 To UBound(B64())
        Rev64(B64(I1)) = I1
    Next I1
End Sub


Public Function PasswordDecrypt(CryptedKey As String) As String
    Dim Reg         As New CRegistry, _
        Key         As String, _
        tgt()       As Byte
        
    If Reg.RegValueGet(HKEY_CURRENT_USER, "Software\ActiveVB\ActiveVB Messenger", "ConfigKey", Key) = regValueGetOK Then
        If CryptedKey <> "" Then
            Call CryptoInstance.Crypt(StrConv(CryptedKey, vbFromUnicode), tgt(), Key, False, 0, False)
            PasswordDecrypt = StrConv(tgt(), vbUnicode)
        Else
            PasswordDecrypt = CryptedKey
        End If
    End If
    
    If PasswordDecrypt = "" Then PasswordDecrypt = CryptedKey
End Function

Public Function PasswordEncrypt(Password As String) As String
    Dim Reg         As New CRegistry, _
        Key         As String, _
        tgt()       As Byte
    
    If Reg.RegValueGet(HKEY_CURRENT_USER, "Software\ActiveVB\ActiveVB Messenger", "ConfigKey", Key) = regValueGetOK Then
        If LenB(Password) > 0 Then
            Call CryptoInstance.Crypt(StrConv(Password, vbFromUnicode), tgt(), Key, False, 0, False)
            PasswordEncrypt = StrConv(tgt(), vbUnicode)
        End If
    Else
        'this seems to be the first time the function is called'
        Dim KeyEx   As New CKeyExchange
        
        Key = KeyEx.CreateKey(128)
        Call Reg.RegValueSet(HKEY_CURRENT_USER, "Software\ActiveVB\ActiveVB Messenger", "ConfigKey", Key)
        'Changed by Kai (08.03.2005) Insert LenB()
        If LenB(Password) > 0 Then
            Call CryptoInstance.Crypt(StrConv(Password, vbFromUnicode), tgt(), Key, False, 0, False)
            PasswordEncrypt = StrConv(tgt(), vbUnicode)
        End If
    End If
End Function


