Attribute VB_Name = "modFormDocking"
Option Explicit

'################################################################################
' Modul        : modFormDocking
' Beschreibung : Dockende Formulare
'                in VB
'
' Erstellt von : Benjamin Wilger, Christoph von Wittich
' Erstellt am  : ?

Private Const WMSZ_BOTTOMLEFT As Long = 7
Private Const WMSZ_LEFT As Long = 1
Private Const WMSZ_TOP As Long = 3
Private Const WMSZ_TOPLEFT As Long = 4
Private Const WMSZ_TOPRIGHT As Long = 5

Public Enum SnapFormMode
    Moving = 1
    Sizing = 2
End Enum

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public MouseX As Long, MouseY As Long
Private SnappedX As Boolean, SnappedY As Boolean

Private Declare Function SystemParametersInfo_Rect Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As RECT, ByVal fuWinIni As Long) As Long
Private Declare Function OffsetRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function GetWindowRect Lib "user32.dll" (ByVal hWnd As Long, ByRef lpRect As RECT) As Long
Public Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long

Public Sub DockFormRect(ByVal hWnd As Long, ByVal Mode As SnapFormMode, GivenRect As RECT, Optional SizingEdge As Long, Optional MouseX As Long, Optional MouseY As Long)
    Const SPI_GETWORKAREA As Long = 48
    Dim Rects() As RECT
    Dim p As POINTAPI
    Dim frm As Form, i As Long, diffX As Long, diffY As Long
    Dim tmpRect As RECT, W As Long, H As Long, frmRect As RECT
    Dim XPos As Long, YPos As Long
    Dim tmpXPos As Long, tmpYPos As Long
    Dim tmpMouseX As Long, tmpMouseY As Long
    Dim FoundX As Boolean, FoundY As Boolean
    ReDim Rects(0 To 0)
    SystemParametersInfo_Rect SPI_GETWORKAREA, vbNull, Rects(0), 0
    i = 1
    For Each frm In Forms
        If frm.Visible And Not frm.hWnd = hWnd Then
            ReDim Preserve Rects(0 To i)
            GetWindowRect frm.hWnd, Rects(i)
            i = i + 1
        End If
    Next frm
    diffX = 12
    diffY = 12
    tmpRect = GivenRect
    GetWindowRect hWnd, frmRect
    If Mode = Moving Then
        GetCursorPos p
        If SnappedX Then
            tmpMouseX = p.X - tmpRect.Left
            OffsetRect tmpRect, tmpMouseX - MouseX, 0
            OffsetRect GivenRect, tmpMouseX - MouseX, 0
        Else
            MouseX = p.X - tmpRect.Left
        End If
        If SnappedY Then
            tmpMouseY = p.Y - tmpRect.Top
            OffsetRect tmpRect, 0, tmpMouseY - MouseY
            OffsetRect GivenRect, 0, tmpMouseY - MouseY
        Else
            MouseY = p.Y - tmpRect.Top
        End If
    End If
    W = tmpRect.Right - tmpRect.Left
    H = tmpRect.Bottom - tmpRect.Top
    If Mode = Moving Then
        For i = 0 To UBound(Rects)
            If (tmpRect.Left >= (Rects(i).Left - 12) And _
                tmpRect.Left <= (Rects(i).Left + 12)) And _
                ((tmpRect.Top - 12) < Rects(i).Bottom And _
                (tmpRect.Bottom + 12) > Rects(i).Top) And _
                Abs(tmpRect.Left - Rects(i).Left) < diffX _
                Then
                GivenRect.Left = Rects(i).Left
                GivenRect.Right = GivenRect.Left + W
                diffX = Abs(tmpRect.Left - Rects(i).Left)
                FoundX = True
            ElseIf i > 0 And (tmpRect.Left >= (Rects(i).Right - 12) And _
                tmpRect.Left <= (Rects(i).Right + 12)) And _
                ((tmpRect.Top - 12) < Rects(i).Bottom And _
                (tmpRect.Bottom + 12) > Rects(i).Top) And _
                Abs(tmpRect.Left - Rects(i).Right) < diffX _
                Then
                GivenRect.Left = Rects(i).Right
                GivenRect.Right = GivenRect.Left + W
                diffX = Abs(tmpRect.Left - Rects(i).Right)
                FoundX = True
            ElseIf i > 0 And (tmpRect.Right >= (Rects(i).Left - 12) And _
                tmpRect.Right <= (Rects(i).Left + 12)) And _
                ((tmpRect.Top - 12) < Rects(i).Bottom And _
                (tmpRect.Bottom + 12) > Rects(i).Top) And _
                Abs(tmpRect.Right - Rects(i).Left) < diffX _
                Then
                GivenRect.Right = Rects(i).Left
                GivenRect.Left = GivenRect.Right - W
                diffX = Abs(tmpRect.Right - Rects(i).Left)
                FoundX = True
            ElseIf (tmpRect.Right >= (Rects(i).Right - 12) And _
                tmpRect.Right <= (Rects(i).Right + 12)) And _
                ((tmpRect.Top - 12) < Rects(i).Bottom And _
                (tmpRect.Bottom + 12) > Rects(i).Top) And _
                Abs(tmpRect.Right - Rects(i).Right) < diffX _
                Then
                GivenRect.Right = Rects(i).Right
                GivenRect.Left = GivenRect.Right - W
                diffX = Abs(tmpRect.Right - Rects(i).Right)
                FoundX = True
            End If
            'Y
            If (tmpRect.Top >= (Rects(i).Top - 12) And _
                tmpRect.Top <= (Rects(i).Top + 12)) And _
                ((tmpRect.Left - 12) < Rects(i).Right And _
                (tmpRect.Right + 12) > Rects(i).Left) And _
                Abs(tmpRect.Top - Rects(i).Top) < diffY _
                Then
                GivenRect.Top = Rects(i).Top
                GivenRect.Bottom = GivenRect.Top + H
                diffY = Abs(tmpRect.Top - Rects(i).Top)
                FoundY = True
            ElseIf i > 0 And (tmpRect.Top >= (Rects(i).Bottom - 12) And _
                tmpRect.Top <= (Rects(i).Bottom + 12)) And _
                ((tmpRect.Left - 12) < Rects(i).Right And _
                (tmpRect.Right + 12) > Rects(i).Left) And _
                Abs(tmpRect.Top - Rects(i).Bottom) < diffY _
                Then
                GivenRect.Top = Rects(i).Bottom
                GivenRect.Bottom = GivenRect.Top + H
                diffY = Abs(tmpRect.Top - Rects(i).Bottom)
                FoundY = True
            ElseIf i > 0 And (tmpRect.Bottom >= (Rects(i).Top - 12) And _
                tmpRect.Bottom <= (Rects(i).Top + 12)) And _
                ((tmpRect.Left - 12) < Rects(i).Right And _
                (tmpRect.Right + 12) > Rects(i).Left) And _
                Abs(tmpRect.Bottom - Rects(i).Top) < diffY _
                Then
                GivenRect.Bottom = Rects(i).Top
                GivenRect.Top = GivenRect.Bottom - H
                diffY = Abs(tmpRect.Bottom - Rects(i).Top)
                FoundY = True
            ElseIf (tmpRect.Bottom >= (Rects(i).Bottom - 12) And _
                tmpRect.Bottom <= (Rects(i).Bottom + 12)) And _
                ((tmpRect.Left - 12) < Rects(i).Right And _
                (tmpRect.Right + 12) > Rects(i).Left) And _
                Abs(tmpRect.Bottom - Rects(i).Bottom) < diffY _
                Then
                GivenRect.Bottom = Rects(i).Bottom
                GivenRect.Top = GivenRect.Bottom - H
                diffY = Abs(tmpRect.Bottom - Rects(i).Bottom)
                FoundY = True
            End If
        Next i
        SnappedX = FoundX
        SnappedY = FoundY
    ElseIf Mode = Sizing Then
        If SizingEdge = WMSZ_LEFT Or SizingEdge = WMSZ_TOPLEFT Or SizingEdge = WMSZ_BOTTOMLEFT Then
            XPos = GivenRect.Left
        Else
            XPos = GivenRect.Right
        End If
        If SizingEdge = WMSZ_TOP Or SizingEdge = WMSZ_TOPLEFT Or SizingEdge = WMSZ_TOPRIGHT Then
            YPos = GivenRect.Top
        Else
            YPos = GivenRect.Bottom
        End If
        tmpXPos = XPos
        tmpYPos = YPos
        For i = 0 To UBound(Rects)
            If ((tmpXPos >= (Rects(i).Left - 12) And _
                tmpXPos <= (Rects(i).Left + 12)) And _
                ((tmpRect.Top - 12) < Rects(i).Bottom And _
                (tmpRect.Bottom + 12) > Rects(i).Top) And _
                Abs(tmpXPos - Rects(i).Left) < diffX) _
                Then
                XPos = Rects(i).Left
                diffX = Abs(tmpXPos - Rects(i).Left)
            ElseIf (tmpXPos >= (Rects(i).Right - 12) And _
                tmpXPos <= (Rects(i).Right + 12)) And _
                ((tmpRect.Top - 12) < Rects(i).Bottom And _
                (tmpRect.Bottom + 12) > Rects(i).Top) And _
                Abs(tmpXPos - Rects(i).Right) < diffX _
                Then
                XPos = Rects(i).Right
                diffX = Abs(tmpXPos - Rects(i).Right)
            End If
            'Y
            If (tmpYPos >= (Rects(i).Top - 12) And _
                tmpYPos <= (Rects(i).Top + 12)) And _
                ((tmpRect.Left - 12) < Rects(i).Right And _
                (tmpRect.Right + 12) > Rects(i).Left) And _
                Abs(tmpYPos - Rects(i).Top) < diffY _
                Then
                YPos = Rects(i).Top
                diffY = Abs(tmpYPos - Rects(i).Top)
            ElseIf (tmpYPos >= (Rects(i).Bottom - 12) And _
                tmpYPos <= (Rects(i).Bottom + 12)) And _
                ((tmpRect.Left - 12) < Rects(i).Right And _
                (tmpRect.Right + 12) > Rects(i).Left) And _
                Abs(tmpYPos - Rects(i).Bottom) < diffY _
                Then
                YPos = Rects(i).Bottom
                diffY = Abs(tmpYPos - Rects(i).Bottom)
            End If
        Next i
        If SizingEdge = WMSZ_LEFT Or SizingEdge = WMSZ_TOPLEFT Or SizingEdge = WMSZ_BOTTOMLEFT Then
            GivenRect.Left = XPos
        Else
            GivenRect.Right = XPos
        End If
        If SizingEdge = WMSZ_TOP Or SizingEdge = WMSZ_TOPLEFT Or SizingEdge = WMSZ_TOPRIGHT Then
            GivenRect.Top = YPos
        Else
            GivenRect.Bottom = YPos
        End If
    End If
    
End Sub





